/*jshint smarttabs:true, eqeqeq:false, eqnull:true, laxbreak:true*/
/**
 * @author
 * directive template
 */
(function(window, vx, undefined) {'use strict';

	var mod = vx.module("ui.libraries");
	mod.directive("*vSubmit", function() {
		return function(scope, element, attrs) {
			element.bind('submit', function(event) {
				var form = scope[attrs.name];
				var inputCtrls = attrs.$$element[0];
				for(var i = 0; i < inputCtrls.length; i++) {
					var ctrl = inputCtrls[i];
					if(['input', 'select'].indexOf(ctrl.tagName.toLowerCase()) !== -1) {
						ctrl.blur();
					}
					var validateAttr = ctrl.getAttribute("validate") || true;
					//默认原输入域的验证属性
					if((ctrl.nodeName === "BUTTON") || (validateAttr === 'false') || ctrl.type==='checkbox') {
						continue;
					}
					var message = {
						required : ctrl.getAttribute("required-message") || "不能为空",
						min : ctrl.getAttribute("min-message") || "最小值:" + ctrl.getAttribute("min"),
						max : ctrl.getAttribute("max-message") || "最大值:" + ctrl.getAttribute("max"),
						minlength : ctrl.getAttribute("minlength-message") || "最小长度:" + ctrl.getAttribute("v-minlength"),
						maxlength : ctrl.getAttribute("maxlength-message") || "最大长度:" + ctrl.getAttribute("v-maxlength"),
						pattern : ctrl.getAttribute("pattern-message") || "格式不正确，请重新输入"
					};
					var ctrlName = ctrl['name'] || ctrl['id'];
					var ctrlComment = ("[" + (ctrl.parentNode.previousElementSibling && ctrl.parentNode.previousElementSibling.innerText || ctrl.placeholder) + "]").replace(/\t\n /g, "");
					for(var key in form.$error) {
						for(var j = 0; j < form.$error[key].length; j++) {
							if(ctrlName == form.$error[key][j].$name) {
								scope.toast(ctrlComment + message[key]);
								return;
							}
						}
					}
				}
				scope.$apply(attrs.vSubmit);
				event.stopPropagation();
				event.preventDefault();
			});
		};
	});
})(window, window.vx);

/*jshint smarttabs:true, eqeqeq:false, eqnull:true, laxbreak:true*/
/**
 * pager directive
 * 如果element包含“constation”属性，则会将结果列表用“constation”属性值进行过滤，将过滤结果展示到页面
 * @auther
 */

(function(window, vx, $) {'use strict';

	var mod = vx.module("ui.libraries");

	mod.directive('vPager', ['$compile', '$filter',function($compile, $filter) {
		var vPagerDefinition = {
			compile : function compile(element, attr, transclude) {
				var PAGE_NAME = element.attr('PageName') || element.attr('pageName') || element.attr('pagename') || 'PAGE';
				var PAGE_SIZE = element.attr('PageSize') || element.attr('pageSize') || element.attr('pagesize') || 5;
				PAGE_SIZE = parseInt(PAGE_SIZE);
				var PAGE_ATTR = element.attr('v-pager');
				var constation = element.attr('constation');
				var LIST_NAME = PAGE_ATTR.match(/in\s*(\w*)$/)[1];
				element.removeAttr('v-pager');
				if(constation == null || constation == undefined){
					element.attr('v-repeat', PAGE_ATTR.replace(/in\s*(\w*)$/, 'in ' + 
							PAGE_NAME + '.' + LIST_NAME));
				}else{
					element.attr('v-repeat', PAGE_ATTR.replace(/in\s*(\w*)$/, 'in ' + 
							PAGE_NAME + '.' + LIST_NAME+'|filter:'+constation));
				}
				
				return {
					post : function postLink(scope, element, attrs) {
						var NewPage = function(page, list) {
							var flag = false;
							page.$_pageInit = function() {
								page.PageIndex = 0;
								
								page.RecordNumber = list.length;
								page.CurrentPage = list.length == 0 ? 0 : 1;
								page.PageNumber = Math.ceil(list.length / PAGE_SIZE);
								page.$_pageSize = PAGE_SIZE;
								page[LIST_NAME] = list.slice(0, PAGE_SIZE);
							};
							page.moreNextPage = function() {
								var nextStart = pageNext();
								page[LIST_NAME] = page[LIST_NAME].concat(scope[LIST_NAME].slice(nextStart, nextStart + PAGE_SIZE));
								if(page[LIST_NAME].length >= scope[LIST_NAME].length) {
									$(nextButton).hide();
								}
							};
							page.nextPage = function() {
								page.PageIndex = page.PageIndex + page.$_pageSize;
								page.CurrentPage++;
								changePage();
							};
							page.prevPage = function() {
								page.PageIndex = page.PageIndex - page.$_pageSize;
								page.CurrentPage--;
								changePage();
							};
							page.topPage = function() {
								page.PageIndex = 0;
								page.CurrentPage = 1;
								changePage();
							};
							page.bottomPage = function() {
								page.PageIndex = PAGE_SIZE * (page.PageNumber - 1);
								page.CurrentPage = page.PageNumber;
								changePage();
							};
							page.changes = function(){
								flag = true;
								changePage();
							};
							function changePage() {
								var cacheList = scope[LIST_NAME];
								var filterList;
								if(constation == null || constation == undefined){
									filterList = cacheList;
								}else{
									filterList = $filter('filter')(cacheList,scope[constation]);
								}
								if(flag){
									NewPage(scope[PAGE_NAME], filterList||[]);
								}
								flag = false;
								page[LIST_NAME] = filterList.slice(page.PageIndex, page.PageIndex + PAGE_SIZE);
								window.scrollTo(0, 0);
							}
							page.$_pageInit();
						};
						$compile(element)(scope);
						scope.$watch(LIST_NAME, function(list) {
							scope[PAGE_NAME] = scope[PAGE_NAME] || {};
							NewPage(scope[PAGE_NAME], list||[]);
						});
					}
				};
			}
		};
		return vPagerDefinition;
	}]);
})(window, window.vx, window.$);

/**
 * input directive
 * Call native keyboard program
 * @auther
 */

(function(window,vx,$){
	'use strict';
	
	var mod = vx.module("ui.libraries");
	
	mod.directive("input", ["$os", "$nativeCall", function($os, $nativeCall){
		return {
			restrict: 'E',
			compile: function(element, attr, transclude){
				var type = element.attr("type");
				// handle input number.
				if(type === "number"){
					// default number length's 15.
					var maxlength = element.attr("maxlength")|| 30;
					maxlength = parseFloat(maxlength) > 30 ? 30 : maxlength;
					element.bind("input", function(){
						this.value = "" + this.value;
						// substring "."
						if(this.value.indexOf('.')!=-1){
							var index = this.value.indexOf('.');
							this.value = this.value.substring(0,index+3);
						}
						// if value's length over maxlength
						if(this.value && this.value.length > maxlength){
							this.value = this.value.substring(0, maxlength);
						}
					});
				}
				if(type === "text"){
					var maxlength = element.attr("maxlength") || 30;
					element.bind("input", function(){
						// if value's length over maxlength
						if(this.value && this.value.length > maxlength){
							this.value = this.value.substring(0, maxlength);
						}
					});
				}
				if(($os.android || $os.wphone) && type==="date"){
					var date = element[0];
					var ediv = document.createElement("div");
					ediv.id = "mapp_" + date.id;
					ediv.className = "mapp_date " + date.className;
					ediv.style.marginLeft = "0";
					ediv.innerHTML = date.value ? date.value : date.placeholder;
					vx.element(ediv).attr("v-bind", attr.vModel);
					vx.element(ediv).bind("click", function(e){
						e.preventDefault();
						var that = this;
						$nativeCall.datePicker(function(value){
							that.innerHTML = value;
							vx.element(that).trigger("input");
						}, date.value);
					});
					vx.element(ediv).bind("input", function(){
						date.value = this.innerHTML;
						vx.element(date).trigger("input");
					});
					element[0].parentNode.appendChild(ediv);
					element[0].style.display="none";
				}
			}
		}
	}]);
	
})(window,window.vx,window.$);

/*jshint smarttabs:true, eqeqeq:false, eqnull:true, laxbreak:true*/
/**
 * pager directive
 * @auther
 */

(function(window, vx, $) {'use strict';

	var mod = vx.module("ui.libraries");

	mod.directive('vMorepage', ['$compile', function($compile) {
		var vPageDefinition = {
			compile : function compile(element, attr, transclude) {
				var PAGE_NAME = element.attr('PageName')|| element.attr('pageName') || element.attr('pagename')|| 'PAGE';
				var PAGE_SIZE = element.attr('PageSize')|| element.attr('pageSize') || element.attr('pagesize')|| 5;
				PAGE_SIZE = parseInt(PAGE_SIZE);
				var PAGE_ATTR = element.attr('v-morepage');
				var LIST_NAME = PAGE_ATTR.match(/in\s*(\w*)$/)[1];
		    	element.removeAttr('v-morepage');
				element.attr('v-repeat', PAGE_ATTR.replace(/in\s*(\w*)$/, 'in '+ PAGE_NAME + '.' + LIST_NAME));
				var nextButton = $('<div class="row-fluid " ><div class="span12 text-center" align="center" v-click="' 
	    				+ PAGE_NAME + '.moreNextPage()"><a id="nextButton">点击查看更多...</a></div></div>');
				$(nextButton).hide();
	    		element.after(nextButton);
				return {
					post : function postLink(scope, element, attrs) {
						var NewPage = function(page, list) {
							page.$_pageInit = function(){
								page.$_pageIndex=0;
								page.$_pageSize=PAGE_SIZE;
								page[LIST_NAME] = list.slice(0, PAGE_SIZE);
								if(list.length < PAGE_SIZE+1) {
									$(nextButton).hide();
								}
								else
									$(nextButton).show();
							};
							function pageNext(){
								page.$_pageIndex = page.$_pageIndex + page.$_pageSize;
								return page.$_pageIndex;
							};
							page.moreNextPage = function() {
								var nextStart = pageNext();
								page[LIST_NAME] = page[LIST_NAME].concat(scope[LIST_NAME].slice(nextStart, nextStart+PAGE_SIZE));
								if(page[LIST_NAME].length >= scope[LIST_NAME].length){
									$(nextButton).hide();
								}
							};
							page.$_pageInit();
						};
						$compile(element)(scope);
						scope.$watch(LIST_NAME, function(list) {
							scope[PAGE_NAME] = scope[PAGE_NAME] || {};
							NewPage(scope[PAGE_NAME], scope[LIST_NAME] || []);
						});
					}
				};
			}
		};
		return vPageDefinition;
	}]);
})(window, window.vx, window.$);

(function(window, vx, $) {'use strict';

	var mod = vx.module("ui.libraries");
	mod.directive('infiniteScroll', [
	  '$rootScope', '$window', '$timeout', function($rootScope, $window, $timeout) {
	    return {
	      link: function(scope, elem, attrs) {
	        var checkWhenEnabled, handler, scrollDistance, scrollEnabled;
	        $window = vx.element($window);
	        scrollDistance = 0;
	        if (attrs.infiniteScrollDistance !== null) {
	          scope.$watch(attrs.infiniteScrollDistance, function(value) {
	            return (scrollDistance = parseInt(value, 10));
	          });
	        }
	        scrollEnabled = true;
	        checkWhenEnabled = false;
	        if (attrs.infiniteScrollDisabled !== null) {
	          scope.$watch(attrs.infiniteScrollDisabled, function(value) {
	            scrollEnabled = !value;
	            if (scrollEnabled && checkWhenEnabled) {
	              checkWhenEnabled = false;
	              return handler();
	            }
	          });
	        }
	        handler = function() {
	          var elementBottom, remaining, shouldScroll, windowBottom;
	          windowBottom = $window.height() + $window.scrollTop();
	          elementBottom = elem.offset().top + elem.height();
	          remaining = elementBottom - windowBottom;
	          shouldScroll = remaining <= $window.height() * scrollDistance;
	          if (shouldScroll && scrollEnabled) {
	            if ($rootScope.$$phase) {
	              return scope.$eval(attrs.infiniteScroll);
	            } else {
	              return scope.$apply(attrs.infiniteScroll);
	            }
	          } else if (shouldScroll) {
	            return (checkWhenEnabled = true);
	          }
	        };
	        $window.on('scroll', handler);
	        scope.$on('$destroy', function() {
	          return $window.off('scroll', handler);
	        });
	        return $timeout((function() {
	          if (attrs.infiniteScrollImmediateCheck) {
	            if (scope.$eval(attrs.infiniteScrollImmediateCheck)) {
	              return handler();
	            }
	          } else {
	            return handler();
	          }
	        }), 0);
	      }
	    };
	  }
	]);
})(window, window.vx, window.$);
(function(window, vx, $) {'use strict';

	var mod = vx.module("ui.libraries");
	mod.directive('switch', [function() {
		var $switchLeft,$switchRight,$label,$div,myClasses,classes,onLabel="ON",offLabel="OFF";
	    return {
	    	required: 'vModel',
	    	restrict: 'AC',
	    	//scope: false,
	    	compile: function(element,attrs,transclude){
	    		return {
	    			pre: function preLink(scope, element, attrs){
						console.log(attrs.onLabel);
						if(attrs.onLabel != ""){
							onLabel = attrs.onLabel;
						}
						if(attrs.offLabel != ""){
							offLabel = attrs.offLabel;
						}
						
						$switchLeft = $('<span>').addClass("switch-left")
							.addClass(myClasses).html(onLabel);
						$switchRight = $('<span>').addClass("switch-right")
							.addClass(myClasses).html(offLabel);
						$label = $('<label>').html("&nbsp;").addClass(myClasses);
						element.wrap($('<div class="make-switch has-switch">'));
						$div = element.wrap($('<div>')).parent().data("animated",false);
						if(element.parent().data("animated") === false)
							$div.addClass('switch-animate').data('animated', true);
						$div.append($switchLeft).append($label).append($switchRight);
						if(!vx.isUndefined(scope[attrs.vModel]))
							element.attr("checked","checked");
						$div.addClass(
							element.is(':checked') ? 'switch-on' : 'switch-off'
							//scope[attrs.vModel]==true ? 'switch-on' : 'switch-off'
						);
	    			},
	    			post: function postLink(scope, element, attrs){
						if(element.is(':checked')){
	    					scope.$apply(function(){scope[attrs.vModel] = true;});
	    				}else{
	    					scope.$apply(function(){scope[attrs.vModel] = false;});
	    				}
	    				var changeStatus = function($this){
							$this.siblings('label').trigger('mousedown').trigger('mouseup').trigger('click');
						};
						$switchLeft.on('click', function(e){
							changeStatus($(this));
						});
						$switchRight.on('click', function(e){
							changeStatus($(this));
						});
						element.on('change', function(e, skipOnChange){
							var $this = $(this), $element = $this.parent()
								,thisState = $this.is(":checked"), state = $element.is('.switch-off');
							e.preventDefault();
							$element.css('left',"");
							if(state === thisState){
								if(thisState){
									$element.removeClass('switch-off').addClass('switch-on');
									scope.$apply(function(){scope[attrs.vModel] = true;});
								}
								else {
									$element.removeClass('switch-on').addClass('switch-off');
									scope.$apply(function(){scope[attrs.vModel] = false;});
								}
								if($element.data('animated') !== false)
									$element.addClass('switch-animate');
								if(typeof skipOnChange === 'boolean' && skipOnChange) return;
								$element.parent().trigger('switch-change',{'el':$this, 'value':thisState});
							}
						});
						element.parent().find('label').on('mousedown touchstart', function(e){
							var $this = $(this);
							var moving = false;
							e.preventDefault();e.stopImmediatePropagation();
							$this.closest('div').removeClass('switch-animate');
							if($this.closest('.has-switch').is('.deactivate')){
								$this.unbind('click');
							} else {
								$this.on('mousemove touchmove', function(e){
									var $element = $(this).closest('.make-switch')
										, relativeX = (e.pageX || e.originalEvent.targetTouches[0].pageX) - $element.offset().left
										, percent = (relativeX / $element.width()) * 100
										, left = 25, right = 75;
									moving = true;
									if(percent < left) 
										percent = left
									else if(percent > right)
										percent = right;
									$element.find('>div').css('left',(percent - right) + "%");
								});
								$this.on('click touchend', function(e){
									var $this = $(this), $myInputBox = $this.siblings('input');
									e.stopImmediatePropagation();
									e.preventDefault();
									$this.unbind('mouseleave');
									if(moving)
										$myInputBox.prop('checked', !(parseInt($this.parent().css('left')) < -25));
									else
										$myInputBox.prop("checked", !$myInputBox.is(":checked"));
									moving = false;
									$myInputBox.trigger('change');
								});
								$this.on('mouseleave', function(e){
									var $this = $(this), $myInputBox = $this.siblings('input');
									e.stopImmediatePropagation();
									e.preventDefault();
									$this.unbind('mouseleave mousemove');
									$this.trigger('mouseup');
									$myInputBox.prop('checked', !(parseInt($this.parent().css('left')) < -25)).trigger('change');
								});
								$this.on('mouseup', function(e){
									e.stopImmediatePropagation();
									e.preventDefault();
									$(this).trigger('mouseleave');
								});
							}
						});
	    			}
	    		}
	    	}
	    }
	}]);
})(window, window.vx, window.$);
/**
 * 服务端分页方式
 * @param callFunction 回调函数
 * @param customPageSize 前端自定义页数 
 * @param startIndexId 分页第一页开始索引 
 * @author ljw
 */
(function(window, vx, undefined) {
	'use strict';
	vx.module('mapp.libraries').factory('Paginator', 
		[function() {
			return function(callFunction, customPageSize, startIndexId) {
				var paginator = {
					// init
					_load : function() {
						var self = this;
						window.scrollTo(0, 0);
						// 回调函数callFunction(recordNumber,currenIndex, pageSize, data)
						callFunction(
							this.recordNumber,
							this.currentIndex,
							this.pageSize,
							function(data) {
								self.currentPageItems = data.List; //集合
								self.recordNumber = data.recordNumber; //总数
								self.pageSize = parseInt(customPageSize || self.pageSize); //页数
								self.totalPage = Math.ceil(self.recordNumber / self.pageSize); //总页数
							}
						);
					},
					// prev Page
					prevPage : function() {
						this.currentIndex -= this.pageSize;
						this.currentPage--;
						this._load();
					},
					// next Page
					nextPage : function() {
						this.currentIndex += this.pageSize;
						this.currentPage++;
						this._load();
					},
					// top Page
					topPage : function() {
						this.currentIndex = startIndexId?parseInt(startIndexId):0;
						this.currentPage = 1;
						this._load();
					},
					// bottom Page
					bottomPage : function() {
						this.currentIndex = (this.totalPage - 1) * this.pageSize;
						this.currentPage = this.totalPage;
						this._load();
					},
					currentPageItems : [],
					currentIndex : startIndexId?parseInt(startIndexId):0,
					totalPage : 0,
					currentPage : 1,
					recordNumber : 0,
					pageSize : customPageSize?parseInt(customPageSize):5
				};
				paginator._load();
				return paginator;
			};
		}]
	);
})(window, window.vx);

/**
 * 获取短信验证码按钮倒计时指令，该指令暂时适用于button控件
 * <button class="btn btn-small" v-Sms="getToken()">获取验证码</button>
 */
(function(window,vx,$){
	'use strict';
	var mod = vx.module("ui.libraries");
	mod.directive("vSms",["$timeout", "$http", "$filter", "$httpBackend", function($timeout, $http, $filter, $httpBackend){
		return{
			restrict:'A',
			scope:false,
			link:function(scope,element,attrs){
				//方便测试，时间改为180秒，以后改为60秒
				var intervalSeconds = 60;	//短信间隔时间
				//var intervalSeconds = 180;	//短信间隔时间
				var history = 0;
				scope.timer = null;
				scope.SmsOtpFlag = true;
				var setTimer = function(value){
					value = value -1;
					var showText = "获取验证码(" + value + ")";
					element.text(showText);
					if (value >= 0) {
							scope.SmsOtpFlag = true;
							scope.timer = $timeout(function() {
								setTimer(value);
							}, 1000);
					} else {
						clearTimeouts();
					}
				};
			
				//当时间为零，重新显示“获取短信验证码”
				var  clearTimeouts = function() {
					if (scope.timer != null) {
						 $timeout.cancel(scope.timer);
						scope.SmsOtpFlag = false;
						element.text("点击获取验证码");
					}
					scope.timer = null;
				};
				setTimer(intervalSeconds);
				element.bind("click" , function(){
					//发送接口
					var sendData = {
							"oldTempId":scope.tempId,
							"transCode":"P888887"
					};
					$http.post("JsonTransServlet", sendData).success(function(data, status, headers, config) {
						if(data.returnCode == "000000000"){
							scope.tempId = data.tempId; 	//用于再次获取验证码
							scope.serialNumber = data.serialNumber;	//用于再次获取验证码
							//时间倒计时
							setTimer(intervalSeconds);
						} else {
							scope.toast(data.returnMsg);
						}
					}).error(function(data, status, headers, config) {
						if(data.returnMsg){
							scope.toast(data.returnMsg);
							return;
						}
					});
					
					
//					var remote = scope.remote;
//					remote.post("JsonTransServlet", sendData, function(data){
//						scope.tempId = data.tempId; 	//用于再次获取验证码
//						scope.serialNumber = data.serialNumber;	//用于再次获取验证码
//						//时间倒计时
//						setTimer(intervalSeconds);
//					});
				});
			}
		}
		
	}]);
})(window,window.vx,window.$);
/**
 * 获取短信验证码按钮倒计时指令，该指令暂时适用于button控件
 * <button class="btn btn-small" v-Sms="getToken()">获取验证码</button>
 */
(function(window,vx,$){
	'use strict';
	var mod = vx.module("ui.libraries");
	mod.directive("vSms",["$timeout",function($timeout){
		return{
			restrict:'A',
			scope:false,
			link:function(scope,element,attrs){
				var fnName = element.attr("v-Sms");
				if(fnName.indexOf('(') != -1){
					fnName = fnName.substring(0,fnName.indexOf('('));
				}				
				var SECEND = 60;
				var count = SECEND;
				var timeid;
				var history = 0;
				var text = "";
				element.bind("click",function(){
					text = element.text();
					element.text(text+"("+SECEND+")");
					element.attr("disabled","disabled");
					decrement();
					history = NativeCall.history.length;
					closeTimeout();
					scope[fnName]();
				});
				
				function decrement(){
					timeid = $timeout(function(){
						count = count - 1;
						if(count == 0){
							$timeout.cancel(timeid);
							element.text(text+"("+count+")");
							element.text(text);
							count = SECEND;
							element.removeAttr("disabled");
						}else{
							element.text(text+"("+count+")");
							decrement();
						}
						
					},1000);
					
				}
				
				//监听页面是否跳转
				var closeId;
				function closeTimeout(){
					closeId = $timeout(function(){
						if(history != NativeCall.history.length){
							$timeout.cancel(timeid);
							$timeout.cancel(closeId);
							element.text(text+"("+count+")");
							element.text(text);
							count = SECEND;
							element.removeAttr("disabled");
						}else{
							closeTimeout();
						}
					},100);
				}
			}
		}
		
	}]);
})(window,window.vx,window.$);



/**
 * 
 *火车票购买，乘车人选择 
 */
(function(window,vx,$){
	'use strict';
	var mod = vx.module("ui.libraries");
	mod.directive("selectPassenger",function(){
		return{
			restrict:'A',
			scope:false,
			link:function(scope,element,attrs){
				element.bind("click",function(){
					//0 选择 ， 1 取消
					if(element.hasClass("selectedPassenger")){
						element.removeClass("selectedPassenger");
						element.addClass("noSelectedPassenger");
						scope.passengerList[attrs.selectPassenger].flag = "1";
					}else{
						element.addClass("selectedPassenger");
						element.removeClass("noSelectedPassenger");
						scope.passengerList[attrs.selectPassenger].flag = "0";
					}
				});
			}
		}
		
	});
})(window,window.vx,window.$);

/**
 * 
 * 模拟手机通讯录
 */
(function(window,vx,$){
	'use strict';
	var mod = vx.module("ui.libraries");
	mod.directive("vScrollView",function(){
		return{
			restrict:'AE',
			scope:false,
			link:function(scope,element,attrs){
				var divNode = attrs.vScrollView;
				element.bind("click" , function(){
					var tid = vx.element(this).find(">a").text();
//					var top = element("#content #divNode_"+tid).offset().top -55;
					var top = vx.element("#content #" + divNode + "_" + tid).offset().top -55;
					vx.element("html,body").animate({scrollTop:top},0);
				});
			}
		}
		
	});
})(window,window.vx,window.$);

/**
 * 
 * 模拟iphone actionsheet
 */
(function(window,vx,$){
	'use strict';
	var mod = vx.module("ui.libraries");
	mod.directive("vActionSheet", ['$compile', '$parse', function($compile, $parse){
		return{
			restrict:'AE',
			scope:false,
			link:function(scope,element,attrs){
				element.bind("click", function(){
					var data = scope.$apply(attrs.vActionSheet);
					
					var targetId = data.targetId;
					var pageId = data.pageId;
					var sheets = data.actions;
					var mask = [];
						mask[mask.length] = '<div id="'+targetId+'" style="height: 100%; width: 100%;background-color: rgba(0, 0, 0, 0.51);position: fixed;top: 0;" >';
						
						mask[mask.length] = '<div class="container-fluid" id="wrap_div" style=" bottom: 0;  position: fixed;  width:100%;*width:99.94680851063829%;">';
						mask[mask.length] ='<div class="well" style=" margin: 0 15px 10px 5px ;">';
					for(var i=0;i<sheets.length;i++){
						var act = sheets[i];
						var line = (i == sheets.length-1)?'':'line';
						mask[mask.length] = '<div class="row-fluid '+line+'">';
						mask[mask.length] = '<div class="span12 text-center" style="padding:0 10px;margin:0;font-size:18px;" v-click="'+act.action+';">';
						mask[mask.length] =act.title;
						//mask[mask.length] = '<button class="btn btn-inverse btn-large btn-block" type="button">Block level button</button>';
						mask[mask.length] ='</div>';
						mask[mask.length] ='</div>';
					}
					scope.cancelSheet = function(){
						vx.element("#content #"+targetId).remove();
					}
						mask[mask.length] = '</div>';
						mask[mask.length] = '<div class="well" style=" margin: 0 15px 10px 5px ;">';
						mask[mask.length] = '<div class="row-fluid" >';
						mask[mask.length] = '<div class="span12 text-center" style="padding:0 10px;font-size:18px;" v-click="cancelSheet();">';
						mask[mask.length] = '取消';
						mask[mask.length] ='</div>';
						mask[mask.length] ='</div>';
						mask[mask.length] ='</div>';
						mask[mask.length] ='</div>';
						mask[mask.length] ='</div>';
						
					
					var tagElem = $compile(mask.join(""))(scope);
					$parse(data.pageBack).assign(scope, "false")
					tagElem.queue(function(next){
						$(this).find("#wrap_div").hide();
						vx.element("#content #" +pageId).append($(this));
						$(this).find("#wrap_div").slideDown(300)
						next();
					}); 
					scope.$apply();
				});
				
			}
		}
		
	}]);
})(window,window.vx,window.$);

/**
 * textarea 自动换行
 * <textarea class="span12 text-right" v-text-autoline  rows="1" placeholder="请输入"></textarea>
 * @param window
 * @param vx
 * @param $
 */
 /**
(function(window,vx,$){
	'use strict';
	var mod = vx.module("ui.libraries");
	mod.directive("vTextAutoline", ['$timeout', function($timeout){
		return{
			restrict:'A',
			scope:false,
			link:function(scope,element,attrs){
				element.css("padding-right","8px");
				function resize () {
					var text = element;
					text[0].style.height = 'auto';
					text.height(text[0].scrollHeight-20);
				}
				function delayedResize () {
					$timeout(resize, 0);
				}
				
				$(element).bind("change" , function(){
					delayedResize();
				});
				$(element).bind("cut" , function(){
					delayedResize();
				});
				$(element).bind("paste" , function(){
					delayedResize();
				});
				$(element).bind("drop" , function(){
					delayedResize();
				});
				$(element).bind("keydown" , function(){
					delayedResize();
				});
				$(element).bind("keyup" , function(){
					delayedResize();
				});
			}
		}
		
	}]);
})(window,window.vx,window.$);
**/