/*jshint smarttabs:true, eqeqeq:false, eqnull:true, laxbreak:true*/
/**
 * @author
 * directive template
 */
(function(window, vx, undefined) {'use strict';

	var mod = vx.module("ui.libraries");
	mod.directive("*vSubmit", function() {
		return function(scope, element, attrs) {
			element.bind('submit', function(event) {
				var form = scope[attrs.name];
				var inputCtrls = attrs.$$element[0];
				for(var i = 0; i < inputCtrls.length; i++) {
					var ctrl = inputCtrls[i];
					if(['input', 'select'].indexOf(ctrl.tagName.toLowerCase()) !== -1) {
						ctrl.blur();
					}
					var validateAttr = ctrl.getAttribute("validate") || true;
					//默认原输入域的验证属性
					if((ctrl.nodeName === "BUTTON") || (validateAttr === 'false') || ctrl.type==='checkbox') {
						continue;
					}
					var message = {
						required : ctrl.getAttribute("required-message") || "不能为空",
						min : ctrl.getAttribute("min-message") || "最小值:" + ctrl.getAttribute("min"),
						max : ctrl.getAttribute("max-message") || "最大值:" + ctrl.getAttribute("max"),
						minlength : ctrl.getAttribute("minlength-message") || "最小长度:" + ctrl.getAttribute("v-minlength"),
						maxlength : ctrl.getAttribute("maxlength-message") || "最大长度:" + ctrl.getAttribute("v-maxlength"),
						pattern : ctrl.getAttribute("pattern-message") || "格式不正确"
					};
					var ctrlName = ctrl['name'] || ctrl['id'];
					var ctrlComment = "[" + (ctrl.parentNode.previousElementSibling.innerText || ctrl.placeholder) + "]";
					ctrlComment.replace();
					for(var key in form.$error) {
						for(var j = 0; j < form.$error[key].length; j++) {
							if(ctrlName == form.$error[key][j].$name) {
								scope.toast(ctrlComment + message[key]);
								return;
							}
						}
					}
				}
				scope.$apply(attrs.vSubmit);
				event.stopPropagation();
				event.preventDefault();
			});
		};
	});
})(window, window.vx);

/*jshint smarttabs:true, eqeqeq:false, eqnull:true, laxbreak:true*/
/**
 * pager directive
 * @auther
 */

(function(window, vx, $) {'use strict';

	var mod = vx.module("ui.libraries");

	mod.directive('vPager', ['$compile',function($compile) {
		var vPagerDefinition = {
			compile : function compile(element, attr, transclude) {
				var PAGE_NAME = element.attr('PageName') || element.attr('pageName') || element.attr('pagename') || 'PAGE';
				var PAGE_SIZE = element.attr('PageSize') || element.attr('pageSize') || element.attr('pagesize') || 5;
				PAGE_SIZE = parseInt(PAGE_SIZE);
				var PAGE_ATTR = element.attr('v-pager');
				var LIST_NAME = PAGE_ATTR.match(/in\s*(\w*)$/)[1];
				element.removeAttr('v-pager');
				element.attr('v-repeat', PAGE_ATTR.replace(/in\s*(\w*)$/, 'in ' + PAGE_NAME + '.' + LIST_NAME));
				return {
					post : function postLink(scope, element, attrs) {
						var NewPage = function(page, list) {
							page.$_pageInit = function() {
								page.PageIndex = 0;
								
								page.RecordNumber = list.length;
								page.CurrentPage = list.length == 0 ? 0 : 1;
								page.PageNumber = Math.ceil(list.length / PAGE_SIZE);
								page.$_pageSize = PAGE_SIZE;
								page[LIST_NAME] = list.slice(0, PAGE_SIZE);
							};
							page.moreNextPage = function() {
								var nextStart = pageNext();
								page[LIST_NAME] = page[LIST_NAME].concat(scope[LIST_NAME].slice(nextStart, nextStart + PAGE_SIZE));
								if(page[LIST_NAME].length >= scope[LIST_NAME].length) {
									$(nextButton).hide();
								}
							};
							page.nextPage = function() {
								page.PageIndex = page.PageIndex + page.$_pageSize;
								page.CurrentPage++;
								changePage();
							};
							page.prevPage = function() {
								page.PageIndex = page.PageIndex - page.$_pageSize;
								page.CurrentPage--;
								changePage();
							};
							page.topPage = function() {
								page.PageIndex = 0;
								page.CurrentPage = 1;
								changePage();
							};
							page.bottomPage = function() {
								page.PageIndex = PAGE_SIZE * (page.PageNumber - 1);
								page.CurrentPage = page.PageNumber;
								changePage();
							};
							function changePage() {
								page[LIST_NAME] = list.slice(page.PageIndex, page.PageIndex + PAGE_SIZE);
								window.scrollTo(0, 0);
							}


							page.$_pageInit();
						};
						$compile(element)(scope);
						scope.$watch(LIST_NAME, function(list) {
							scope[PAGE_NAME] = scope[PAGE_NAME] || {};
							NewPage(scope[PAGE_NAME], scope[LIST_NAME] || []);
						});
					}
				};
			}
		};
		return vPagerDefinition;
	}]);
})(window, window.vx, window.$);

/**
 * input directive
 * Call native keyboard program
 * @auther
 */

(function(window,vx,$){
	'use strict';
	
	var mod = vx.module("ui.libraries");
	
	mod.directive("input", ["$os", "$nativeCall", "$timeout", "$rootScope",
	                        function($os, $nativeCall, $timeout, $rootScope){
		return {
			restrict: 'E',
			compile: function(element, attr, transclude){
				var type = element.attr("type");
				// handle input number.
				if(type === "number"){
					var maxlength = element.attr("maxlength") || 15;
					element.bind("input", function(){
						// convert number to string
						this.value = "" + this.value;
						// if value's length over maxlength
						if(this.value && this.value.length > maxlength){
							this.value = this.value.substring(0, maxlength);
						}
					});
				}
				if(($os.android || $os.wphone) && type==="date"){
					var date = element[0];
					var ediv = document.createElement("div");
					ediv.id = "mapp_" + date.id;
					ediv.className = "mapp_date " + date.className;
					ediv.style.marginLeft = "0";
					ediv.innerHTML = date.value ? date.value : date.placeholder;
					vx.element(ediv).attr("v-bind", attr.vModel);
					vx.element(ediv).bind("click", function(e){
						e.preventDefault();
						var that = this;
						$nativeCall.datePicker(function(value){
							that.innerHTML = value;
							vx.element(that).trigger("input");
						}, date.value);
					});
					vx.element(ediv).bind("input", function(){
						date.value = this.innerHTML;
						vx.element(date).trigger("input");
					});
					element[0].parentNode.appendChild(ediv);
					element[0].style.display="none";
				}
				if("button" === type){
					var key = element.attr("v-disabled");
					if(key){
						var timeout = element.attr("timeout") || 1000;
						element.bind("click", function(){
							// add disabled
							$rootScope[key] = true;
							$timeout(function() {
								// remove disabled
								delete $rootScope[key];
							}, timeout);
						});
					}
				}
			}
		}
	}]);
	
})(window,window.vx,window.$);

/*jshint smarttabs:true, eqeqeq:false, eqnull:true, laxbreak:true*/
/**
 * pager directive
 * @auther
 */

(function(window, vx, $) {'use strict';

	var mod = vx.module("ui.libraries");

	mod.directive('vMorepage', ['$compile', function($compile) {
		var vPageDefinition = {
			compile : function compile(element, attr, transclude) {
				var PAGE_NAME = element.attr('PageName')|| element.attr('pageName') || element.attr('pagename')|| 'PAGE';
				var PAGE_SIZE = element.attr('PageSize')|| element.attr('pageSize') || element.attr('pagesize')|| 5;
				PAGE_SIZE = parseInt(PAGE_SIZE);
				var PAGE_ATTR = element.attr('v-morepage');
				var LIST_NAME = PAGE_ATTR.match(/in\s*(\w*)$/)[1];
		    	element.removeAttr('v-morepage');
				element.attr('v-repeat', PAGE_ATTR.replace(/in\s*(\w*)$/, 'in '+ PAGE_NAME + '.' + LIST_NAME));
	    		var nextButton = $('<a class="btn btn-info" id="nextButton" style="width:100%;padding-left:0;padding-right:0;" v-click="' 
	    				+ PAGE_NAME + '.moreNextPage()">查看更多</a>');
	    		element.after(nextButton);
				return {
					post : function postLink(scope, element, attrs) {
						var NewPage = function(page, list) {
							page.$_pageInit = function(){
								page.$_pageIndex=0;
								page.$_pageSize=PAGE_SIZE;
								page[LIST_NAME] = list.slice(0, PAGE_SIZE);
								if(list.length < PAGE_SIZE+1) {
									$(nextButton).hide();
								}
								else
									$(nextButton).show();
							};
							function pageNext(){
								page.$_pageIndex = page.$_pageIndex + page.$_pageSize;
								return page.$_pageIndex;
							};
							page.moreNextPage = function() {
								var nextStart = pageNext();
								page[LIST_NAME] = page[LIST_NAME].concat(scope[LIST_NAME].slice(nextStart, nextStart+PAGE_SIZE));
								if(page[LIST_NAME].length >= scope[LIST_NAME].length){
									$(nextButton).hide();
								}
							};
							page.$_pageInit();
						};
						$compile(element)(scope);
						scope.$watch(LIST_NAME, function(list) {
							scope[PAGE_NAME] = scope[PAGE_NAME] || {};
							NewPage(scope[PAGE_NAME], scope[LIST_NAME] || []);
						});
					}
				};
			}
		};
		return vPageDefinition;
	}]);
})(window, window.vx, window.$);

(function(window, vx, $) {'use strict';

	var mod = vx.module("ui.libraries");
	mod.directive('infiniteScroll', [
	  '$rootScope', '$window', '$timeout', function($rootScope, $window, $timeout) {
	    return {
	      link: function(scope, elem, attrs) {
	        var checkWhenEnabled, handler, scrollDistance, scrollEnabled;
	        $window = vx.element($window);
	        scrollDistance = 0;
	        if (attrs.infiniteScrollDistance !== null) {
	          scope.$watch(attrs.infiniteScrollDistance, function(value) {
	            return (scrollDistance = parseInt(value, 10));
	          });
	        }
	        scrollEnabled = true;
	        checkWhenEnabled = false;
	        if (attrs.infiniteScrollDisabled !== null) {
	          scope.$watch(attrs.infiniteScrollDisabled, function(value) {
	            scrollEnabled = !value;
	            if (scrollEnabled && checkWhenEnabled) {
	              checkWhenEnabled = false;
	              return handler();
	            }
	          });
	        }
	        handler = function() {
	          var elementBottom, remaining, shouldScroll, windowBottom;
	          windowBottom = $window.height() + $window.scrollTop();
	          elementBottom = elem.offset().top + elem.height();
	          remaining = elementBottom - windowBottom;
	          shouldScroll = remaining <= $window.height() * scrollDistance;
	          if (shouldScroll && scrollEnabled) {
	            if ($rootScope.$$phase) {
	              return scope.$eval(attrs.infiniteScroll);
	            } else {
	              return scope.$apply(attrs.infiniteScroll);
	            }
	          } else if (shouldScroll) {
	            return (checkWhenEnabled = true);
	          }
	        };
	        $window.on('scroll', handler);
	        scope.$on('$destroy', function() {
	          return $window.off('scroll', handler);
	        });
	        return $timeout((function() {
	          if (attrs.infiniteScrollImmediateCheck) {
	            if (scope.$eval(attrs.infiniteScrollImmediateCheck)) {
	              return handler();
	            }
	          } else {
	            return handler();
	          }
	        }), 0);
	      }
	    };
	  }
	]);
})(window, window.vx, window.$);
(function(window, vx, $) {'use strict';

	var mod = vx.module("ui.libraries");
	mod.directive('switch', [function() {
		var $switchLeft,$switchRight,$label,$div,myClasses,classes,onLabel="ON",offLabel="OFF";
	    return {
	    	required: 'vModel',
	    	restrict: 'AC',
	    	//scope: false,
	    	compile: function(element,attrs,transclude){
	    		return {
	    			pre: function preLink(scope, element, attrs){
						$switchLeft = $('<span>').addClass("switch-left")
							.addClass(myClasses).html(onLabel);
						$switchRight = $('<span>').addClass("switch-right")
							.addClass(myClasses).html(offLabel);
						$label = $('<label>').html("&nbsp;").addClass(myClasses);
						element.wrap($('<div class="make-switch has-switch">'));
						$div = element.wrap($('<div>')).parent().data("animated",false);
						if(element.parent().data("animated") === false)
							$div.addClass('switch-animate').data('animated', true);
						$div.append($switchLeft).append($label).append($switchRight);
						if(!vx.isUndefined(scope[attrs.vModel]))
							element.attr("checked","checked");
						$div.addClass(
							element.is(':checked') ? 'switch-on' : 'switch-off'
							//scope[attrs.vModel]==true ? 'switch-on' : 'switch-off'
						);
	    			},
	    			post: function postLink(scope, element, attrs){
	    				var changeStatus = function($this){
							$this.siblings('label').trigger('mousedown').trigger('mouseup').trigger('click');
						};
						$switchLeft.on('click', function(e){
							changeStatus($(this));
						});
						$switchRight.on('click', function(e){
							changeStatus($(this));
						});
						element.on('change', function(e, skipOnChange){
							var $this = $(this), $element = $this.parent()
								,thisState = $this.is(":checked"), state = $element.is('.switch-off');
							e.preventDefault();
							$element.css('left',"");
							if(state === thisState){
								if(thisState){
									$element.removeClass('switch-off').addClass('switch-on');
									scope.$apply(function(){scope[attrs.vModel] = true;});
								}
								else {
									$element.removeClass('switch-on').addClass('switch-off');
									scope.$apply(function(){scope[attrs.vModel] = false;});
								}
								if($element.data('animated') !== false)
									$element.addClass('switch-animate');
								if(typeof skipOnChange === 'boolean' && skipOnChange) return;
								$element.parent().trigger('switch-change',{'el':$this, 'value':thisState});
							}
						});
						element.parent().find('label').on('mousedown touchstart', function(e){
							var $this = $(this);
							var moving = false;
							e.preventDefault();e.stopImmediatePropagation();
							$this.closest('div').removeClass('switch-animate');
							if($this.closest('.has-switch').is('.deactivate')){
								$this.unbind('click');
							} else {
								$this.on('mousemove touchmove', function(e){
									var $element = $(this).closest('.make-switch')
										, relativeX = (e.pageX || e.originalEvent.targetTouches[0].pageX) - $element.offset().left
										, percent = (relativeX / $element.width()) * 100
										, left = 25, right = 75;
									moving = true;
									if(percent < left) 
										percent = left
									else if(percent > right)
										percent = right;
									$element.find('>div').css('left',(percent - right) + "%");
								});
								$this.on('click touchend', function(e){
									var $this = $(this), $myInputBox = $this.siblings('input');
									e.stopImmediatePropagation();
									e.preventDefault();
									$this.unbind('mouseleave');
									if(moving)
										$myInputBox.prop('checked', !(parseInt($this.parent().css('left')) < -25));
									else
										$myInputBox.prop("checked", !$myInputBox.is(":checked"));
									moving = false;
									$myInputBox.trigger('change');
								});
								$this.on('mouseleave', function(e){
									var $this = $(this), $myInputBox = $this.siblings('input');
									e.stopImmediatePropagation();
									e.preventDefault();
									$this.unbind('mouseleave mousemove');
									$this.trigger('mouseup');
									$myInputBox.prop('checked', !(parseInt($this.parent().css('left')) < -25)).trigger('change');
								});
								$this.on('mouseup', function(e){
									e.stopImmediatePropagation();
									e.preventDefault();
									$(this).trigger('mouseleave');
								});
							}
						});
	    			}
	    		}
	    	}
	    }
	}]);
})(window, window.vx, window.$);
/**
 * 服务端分页方式
 * @author ljw
 */
(function(window, vx, undefined) {
	'use strict';
	vx.module('mapp.libraries').factory('Paginator', 
		[function() {
			return function(callFunction) {
				var paginator = {
					// init
					_load : function() {
						var self = this;
						window.scrollTo(0, 0);
						// 回调函数callFunction(recordNumber,currenIndex, pageSize, data)
						callFunction(
							this.recordNumber,
							this.currentIndex,
							this.pageSize,
							function(data) {
								self.currentPageItems = data.List; //集合
								self.recordNumber = data.recordNumber; //总数
								self.pageSize = parseInt(data.pageSize || self.pageSize); //页数
								self.totalPage = Math.ceil(self.recordNumber / self.pageSize); //总页数
							}
						);
					},
					// prev Page
					prevPage : function() {
						this.currentIndex -= this.pageSize;
						this.currentPage--;
						this._load();
					},
					// next Page
					nextPage : function() {
						this.currentIndex += this.pageSize;
						this.currentPage++;
						this._load();
					},
					// top Page
					topPage : function() {
						this.currentIndex = 0;
						this.currentPage = 1;
						this._load();
					},
					// bottom Page
					bottomPage : function() {
						this.currentIndex = (this.totalPage - 1) * this.pageSize;
						this.currentPage = this.totalPage;
						this._load();
					},
					currentPageItems : [],
					currentIndex : 0,
					totalPage : 0,
					currentPage : 1,
					recordNumber : 0,
					pageSize : 5
				};
				paginator._load();
				return paginator;
			};
		}]
	);
})(window, window.vx);