/*jshint smarttabs:true, eqeqeq:false, eqnull:true, laxbreak:true*/
/**
 * @author
 * filter template
 */
(function(window, vx) {'use strict';

	//accountNo.$inject = ['$locale'];
	function accountNo() {
		return function(input) {
			if(input !== undefined)
				input=input.replace(/(.{4})/g,"$1 ");
			return input;
		};
	}

	vx.module('ui.libraries').filter('accountNo', accountNo);

})(window, window.vx);

/*jshint smarttabs:true, eqeqeq:false, eqnull:true, laxbreak:true*/
/**
 * @author
 * filter template
 * 大写金额转换
 */
(function(window, vx) {'use strict';

	function amount() {
		return function(input) {
			if (input !== undefined) {
				var strOutput = "", strUnit = '仟佰拾万仟佰拾亿仟佰拾万仟佰拾元角分';
				input += "00";
				var intPos = input.indexOf('.');
				if (intPos >= 0){
					input = input.substring(0, intPos) + input.substr(intPos + 1, 2);
				}
				strUnit = strUnit.substr(strUnit.length - input.length);
				for (var i = 0; i < input.length; i++) {
					strOutput += '零壹贰叁肆伍陆柒捌玖'.substr(input.substr(i, 1), 1) + strUnit.substr(i, 1);
				}
				return strOutput.replace(/零角零分$/, '整').replace(/零[仟佰拾]/g, '零').replace(/零{2,}/g, '零').replace(/零([亿|万])/g, '$1').replace(/零+元/, '元').replace(/亿零{0,3}万/, '亿').replace(/^元/, "零元");
			}
			return input;
		};
	}
	vx.module('ui.libraries').filter('amount', amount);

})(window, window.vx);

/*jshint smarttabs:true, eqeqeq:false, eqnull:true, laxbreak:true*/
/** 币种翻译成中文 
 * @author  
 * filter template
 */
(function(window, vx, undefined) {'use strict';

	function currencyTypeName() {
		return function(input) {
			switch (input) {
				case '01':
					input = '人民币';
					break;
				case '14':
					input = '美元';
					break;
				case '13':
					input = '港币';
					break;
				case '12':
					input = '英镑';
					break;
				case '15':
					input = '瑞士法郎';
					break;
				case '18':
					input = '新加坡元';
					break;	
				case '27':
					input = '日元';
					break;
				case '28':
					input = '加拿大元';
					break;
				case '29':
					input = '澳大利亚元';
					break;
				case '38':
					input = '欧元';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("currencyTypeName",currencyTypeName);

})(window, window.vx);

/*jshint smarttabs:true, eqeqeq:false, eqnull:true, laxbreak:true*/
/** 币种翻译成代号  
 * @author  
 * filter template
 */
(function(window, vx, undefined) {'use strict';

	function currencyTypeValue() {
		return function(input) {
			switch (input) {
				case '01':
					input = 'CNY';
					break;
				case '14':
					input = 'USD';
					break;
				case '13':
					input = 'HKD';
					break;
				case '12':
					input = 'GBP';
					break;
				case '15':
					input = 'CHF';
					break;
				case '18':
					input = 'SGD';
					break;	
				case '27':
					input = 'JPY';
					break;
				case '28':
					input = 'CAD';
					break;
				case '29':
					input = 'AUD';
					break;
				case '38':
					input = 'EUR';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("currencyTypeValue",currencyTypeValue);

})(window, window.vx);


/*jshint smarttabs:true, eqeqeq:false, eqnull:true, laxbreak:true*/
/** 钞汇标识  
 * @author  
 * filter template
 */
(function(window, vx, undefined) {'use strict';

	function cashFlagType() {
		return function(input) {
			switch (input) {
				case '0':
					input = '现钞';
					break;
				case '1':
					input = '现汇';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("cashFlagType",cashFlagType);

})(window, window.vx);
/*jshint smarttabs:true, eqeqeq:false, eqnull:true, laxbreak:true*/
/**
 * @author
 * filter template
 */
(function(window, vx) {'use strict';

	//accountNo.$inject = ['$locale'];
	function trsType() {
		return function(input) {
			if(input !== undefined)
				return input==='D' ? "转入" : "转出";
		};
	}

	vx.module('ui.libraries').filter('trsType', trsType);

})(window, window.vx);

/*jshint smarttabs:true, eqeqeq:false, eqnull:true, laxbreak:true*/
/**
 * @author
 * filter 加密账号    1234****5678
 */
(function(window, vx) {'use strict';

	//accountNo.$inject = ['$locale'];
	function encryptAcNo() {
		return function(input) {
			if(input !== undefined)
				return input.substring(0,4) + "****" + input.substring(input.length-4);
		}
	}

	vx.module('ui.libraries').filter('encryptAcNo', encryptAcNo);

})(window, window.vx);
/**
* filter 卡号后四位    5678
*/
(function(window, vx) {'use strict';

	//accountNo.$inject = ['$locale'];
	function lastAcNo() {
		return function(input) {
			if(input !== undefined)
				return input.substr(input.length-4,4);
		}
	}

	vx.module('ui.libraries').filter('lastAcNo', lastAcNo);

})(window, window.vx);
/*jshint smarttabs:true, eqeqeq:false, eqnull:true, laxbreak:true*/
/**
 * @author
 * filter 卡类型
 */
(function(window, vx) {'use strict';

	function bankAcType() {
		return function(acType) {
			switch(acType){
				case "PMCS":
					return "活期一本通";
				case "PDPB":
					return "借记卡";
				default:
					return acType;
			}
		}
	}

	vx.module('ui.libraries').filter('bankAcType', bankAcType);

})(window, window.vx);

/*jshint smarttabs:true, eqeqeq:false, eqnull:true, laxbreak:true*/
/**
 * @author
 * filter 签约渠道
 */
(function(window, vx) {'use strict';

	function signChangle() {
		return function(changle) {
			switch(changle){
				case "1":
					return "网上银行";
				default:
					return changle;
			}
		}
	}

	vx.module('ui.libraries').filter('signChangle', signChangle);

})(window, window.vx);

/**
 * @author
 * filter 账户权限
 */
(function(window, vx) {'use strict';

	function acPermit() {
		return function(permit) {
			switch(permit){
				case "1":
					return "可转账";
				case "0":
					return "可查询";
				default:
					return permit;
			}
		}
	}

	vx.module('ui.libraries').filter('acPermit', acPermit);

})(window, window.vx);

/**
 * @author
 * filter 账户状态
 */
(function(window, vx) {'use strict';

	function acState() {
		return function(state) {
			switch(state){
				case "0":
					return "正常";
				case "1":
					return "冻结";
				default:
					return state;
			}
		}
	}

	vx.module('ui.libraries').filter('acState', acState);

})(window, window.vx);

/**
 * @author
 * filter Yes OR No
 */
(function(window, vx) {'use strict';

	function YesOrNo() {
		return function(state) {
			switch(state){
				case "1":
					return "是";
				default:
					return "否";
			}
		}
	}

	vx.module('ui.libraries').filter('YesOrNo', YesOrNo);

})(window, window.vx);

/**
 * @author
 * filter RolloverFlag
 * 自动转存
 */
(function(window, vx) {'use strict';

	function RolloverFlag() {
		return function(flag) {
			switch(flag){
				case "4":
					return "默认转存";
				default:
					return "不转存";
			}
		}
	}
	vx.module('ui.libraries').filter('RolloverFlag', RolloverFlag);

})(window, window.vx);

/**
 * 日期格式化
 */
(function(window,vx){'use strict';
	vx.module('ui.libraries').filter('DateFormat',function(){
		return function(input){
			var input_ = input + "";
			if(input_.length > 0){
				if(input_.indexOf("-")>0 || input_.indexOf("/")>0)return input_;
				else{
					return input_.substring(0,4)+"-"+input_.substring(4,6)+"-"+input_.substring(6,8);
				}
			}else{
				return input;
			}
		}
	});
})(window,window.vx);

/**
 * 手机运营商
 */
(function(window,vx){'use strict';
	vx.module('ui.libraries').filter('MobileNumberAgent',function(){
		return function(input){
			var ChinaMobile = "139,138,137,136,135 ,134,188,187,182,159,158,157 ,152 ,150";
			var ChinaUnicom = "130 ,131,132,155,156,186";
			var ChinaNet = "133,153,180,189";
			var input_ = input  ;
			if(input_ && input_.length >= 3){
				var flag = input_.substr(0,3);
				if(ChinaMobile.indexOf(flag, 0)!=-1){
					return "中国移动"
				}else if(ChinaUnicom.indexOf(flag, 0)!=-1){
					return "中国联通";
				}else if(ChinaNet.indexOf(flag, 0)!=-1){
					return "中国电信";
				}else {
					return "未知";
				}
			}
		}
	});
})(window,window.vx);

/*jshint smarttabs:true, eqeqeq:false, eqnull:true, laxbreak:true*/
/**账户类型
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';

	function accountType() {  
		return function(input) {
			switch (input) {
				case '0':
					input = '活期账户';
					break;
				case '1':
					input = '定期存款';
					break;
				case '2':
					input = '个人贷款';
					break;
				case '3':
					input = '公司贷款';
					break;
				case '4':
					input = '定活两便';
					break;
				case '5':
					input = '零存整取';
					break;
				case '6':
					input = '通知存款';
					break;
				case '7':
					input = '协定存款';
					break;
				case '8':
					input = '其它';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("accountType",accountType);

})(window, window.vx);

/*jshint smarttabs:true, eqeqeq:false, eqnull:true, laxbreak:true*/
/**卡类型
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';

	function bankCardType() {  
		return function(input) {
			switch (input) {
				case '0':
					input = '借记卡';
					break;
				case '1':
					input = '本外币一本通';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("bankCardType",bankCardType);

})(window, window.vx);

/*jshint smarttabs:true, eqeqeq:false, eqnull:true, laxbreak:true*/
/**银行卡状态
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';

	function bankCardStatus() {  
		return function(input) {
			switch (input) {
				case '0':
					input = '正常';
					break;
				case '1':
					input = '冻结';
					break;
			}
			return input || "";
		};
	}
	vx.module('ui.libraries').filter("bankCardStatus",bankCardStatus);
})(window, window.vx);

/**储蓄种类
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function saveType() {  
		return function(input) {
			switch (input) {
				case '0':
					input = '一个月';
					break;
				case '1':
					input = '三个月';
					break;
				case '2':
					input = '六个月';
					break;
				case '3':
					input = '一年';
					break;
				case '4':
					input = '两年';
					break;
				case '5':
					input = '三年';
					break;
				case '6':
					input = '五年';
					break;
				case '7':
					input = '一天通知存款';
					break;
				case '8':
					input = '七天通知存款';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("saveType",saveType);

})(window, window.vx);

/**证件类型
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function IDType() {  
		return function(input) {
			switch (input) {
				case '0':
					input = '身份证';
					break;
				case '1':
					input = '军官证';
					break;
				case '2':
					input = '护照';
					break;
				case '3':
					input = '其它';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("IDType",IDType);

})(window, window.vx);

/**红包提取状态
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function envelopesType() {  
		return function(input) {
			switch (input) {
				case '0':
					input = '未取';
					break;
				case '1':
					input = '已提现';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("envelopesType",envelopesType);

})(window, window.vx);

/**交易状态
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function transferStatus() {  
		return function(input) {
			switch (input) {
				case '0':
					input = '未明状态';
					break;
				case '1':
					input = '成功';
					break;
				case '2':
					input = '失败';
					break;
				case '3':
					input = '异常';
					break;
				case '4':
					input = '不存在';
					break;
				case '5':
					input = '已发送';
					break;
				case '6':
					input = '落地未发送';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("transferStatus",transferStatus);

})(window, window.vx);

/**是否保存
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function saveTypeFlag() {  
		return function(input) {
			switch (input) {
				case 'false':
					input = '否';
					break;
				case 'true':
					input = '是';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("saveTypeFlag",saveTypeFlag);

})(window, window.vx);


/**参数转换
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function convertSysVar() { 
		return function(input,type) {
			try{
				var paramMap = sysVarMap[type]
				input = paramMap[input];
			}catch(e){
				input = "";
			}
			
			return input || "";
		};
	}
	vx.module('ui.libraries').filter("convertSysVar",convertSysVar);

})(window, window.vx);

/**
 * 首字母
 */
(function(window,vx){'use strict';
	vx.module('ui.libraries').filter('firstLetter',function(){
		return function(input){
			var first_char ;
			var newStr="";
			for(var i=0;i<input.length;i++){
				var s = $.trim(input).charAt(i);
				var uni = s.charCodeAt(0);//unicode
				if (uni >= 19968 && uni <= 40869) {
					first_char =  my_chinese.charAt(uni - 19968);
				} else if ((uni >= 65 && uni <= 90) || (uni >= 97 && uni <= 122)) {
					first_char =  s.toUpperCase();
				}else{
					first_char =  "Z";
				}	
				newStr += first_char;
			}
			
			return newStr;
		}
	});
})(window,window.vx);

/**
 * 模拟手机通讯录
 * 根据首字母生产 新的list
 */
(function(window,vx){'use strict';
	vx.module('ui.libraries').filter('convertListByFirstChar',['$filter', function($filter){
		return function(sourceList , firstCharKey){
			if(sourceList.length == 0){
				return sourceList;
			}
			var firstCharsStr = ""; 	//sourceList 的 firstCharKey首字母集合
			for(var i=0;i<sourceList.length;i++){
				var firstChar = $filter("firstLetter")(sourceList[i][firstCharKey][0]);
				sourceList[i].firstChar = firstChar;
				if(firstCharsStr.indexOf(firstChar)>=0){
					continue;
				}
				firstCharsStr += firstChar;
			}
			sourceList = $filter("orderBy")(sourceList , "stationId"); 	// 排序
			
			
			var firstCharArray = firstCharsStr.split("").sort(); 	 // 转换数组 排序
//			console.log("firstCharKey首字母集合: " + firstCharArray);
			
			var newList = [];
			for(var i=0;i<firstCharArray.length;i++){
				var json = {"firstChar":firstCharArray[i]}
				var arr = [];
				for(var j=0;j<sourceList.length;j++){
					if(firstCharArray[i] == sourceList[j].firstChar){
						sourceList[j]["index"] = arr.length;
						arr[arr.length] = sourceList[j];
					}
				}
				arr[arr.length-1]["last"] = 0;
				json.arr = arr;
				newList[newList.length] = json;
			}
//			console.log($filter("json")(newList));
			return newList
		}
	}]);
})(window,window.vx);

/**
 * 车票的时间显示
 */
(function(window,vx){'use strict';
	vx.module('ui.libraries').filter('busTicketTimeShow',function(){
		return function(input){
			var ary = input.split(" ");
			if(ary.length>1){
				return ary[1];
			}
			return input;
		}
	});
})(window,window.vx);

/**
 * 车票的取票状态
 */
(function(window,vx){'use strict';
	vx.module('ui.libraries').filter('busTicketFetchState',function(){
		return function(input){
			switch (input) {
			case '0':
				input = '否';
				break;
			case '1':
				input = '是';
				break;
			}
			return input || "";
		}
	});
})(window,window.vx);

/**自助贷款还款方式
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function loanRepayType() {  
		return function(input) {
			switch (input) {
				case '0':
					input = '等额本息';
					break;
				case '1':
					input = '等额本金';
					break;
				case '2':
					input = '到期一次性还本付息';
					break;
				case '3':
					input = '定期结息到期还本';
					break;
				case '4':
					input = '定期结息分期还本';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("loanRepayType",loanRepayType);

})(window, window.vx);


/**自助贷款授信额度激活标志
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function activeFlag() {  
		return function(input) {
			switch (input) {
				case '1':
					input = '生效';
					break;
				case '2':
					input = '待激活';
					break;
				case '3':
					input = '合同终止';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("activeFlag",activeFlag);

})(window, window.vx);

/**交易类型
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function inorOutType() {  
		return function(input) {
			switch (input) {
				case '0':
					input = '收入';
					break;
				case '1':
					input = '支出';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("inorOutType",inorOutType);

})(window, window.vx);

/**赎回标志
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function RedeemType() {  
		return function(input) {
			switch (input) {
				case '0':
					input = '不可赎回 ';
					break;
				case '1':
					input = '可赎回';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("RedeemType",RedeemType);

})(window, window.vx);

/**可撤单标志
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function canCancleType() {  
		return function(input) {
			switch (input) {
				case '0':
					input = '不可撤单';
					break;
				case '1':
					input = '可撤单';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("canCancleType",canCancleType);

})(window, window.vx);

/**交易类别
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function tradeMType() {  
		return function(input) {
			switch (input) {
				case '1':
					input = '认购 ';
					break;
				case '2':
					input = '申购';
					break;
				case '3':
					input = '赎回';
					break;
				case '4':
					input = '购买';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("tradeMType",tradeMType);

})(window, window.vx);

/**贷款状态
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function LoanState() {  
		return function(input) {
			switch (input) {
				case '01':
					input = '正常 ';
					break;
				case '02':
					input = '结清';
					break;
				case '03':
					input = '到期 ';
					break;
				case '04':
					input = '销户';
					break;
				case '05':
					input = '展期 ';
					break;
				case '99':
					input = '其它';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("LoanState",LoanState);

})(window, window.vx);

/*jshint smarttabs:true, eqeqeq:false, eqnull:true, laxbreak:true*/
/**
 * @author
 * filter template
 * 每四位数字一个空格
 */
(function(window, vx) {'use strict';

	function CardPl() {
		return function(input) {
			input = input.replace(/(\d{4})/g,'$1 ').replace(/\s*$/,'');
			return input;
		};
	}
	vx.module('ui.libraries').filter('CardPl', CardPl);

})(window, window.vx);

/**汉字转拼音
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function pingyingConvert() {  
		return function(input) {
			var d = [];
			d[d.length] = "a:阿吖嗄腌锕啊";
			d[d.length] = "ai:埃挨哎唉哀皑癌蔼矮艾碍爱隘捱嗳嗌嫒瑷暧砹锿霭";
			d[d.length] = "an:鞍氨安俺按暗岸胺案谙埯揞庵桉铵鹌黯";
			d[d.length] = "ang:肮昂盎";
			d[d.length] = "ao:凹敖熬翱袄傲奥懊澳坳嗷岙廒遨媪骜獒聱螯鏊鳌鏖";
			d[d.length] = "ba:芭捌扒叭吧笆八疤巴拔跋靶把耙坝霸罢爸茇菝岜灞钯粑鲅魃";
			d[d.length] = "bai:白柏百摆佰败拜稗捭掰";
			d[d.length] = "ban:斑班搬扳般颁板版扮拌伴瓣半办绊阪坂钣瘢癍舨";
			d[d.length] = "bang:邦帮梆榜膀绑棒磅镑傍谤蒡浜";
			d[d.length] = "beng:蚌崩绷甭泵蹦迸嘣甏";
			d[d.length] = "bao:苞胞包褒薄雹保堡饱宝抱报暴豹鲍爆曝勹葆孢煲鸨褓趵龅";
			d[d.length] = "bo:剥玻菠播拨钵波博勃搏铂箔伯帛舶脖膊渤泊驳亳啵饽檗擘礴钹鹁簸跛踣";
			d[d.length] = "bei:杯碑悲卑北辈背贝钡倍狈备惫焙被孛陂邶蓓呗悖碚鹎褙鐾鞴";
			d[d.length] = "ben:奔苯本笨畚坌锛";
			d[d.length] = "bi:逼鼻比鄙笔彼碧蓖蔽毕毙毖币庇痹闭敝弊必壁臂避陛匕俾荜荸萆薜吡哔狴庳愎滗濞弼妣婢嬖璧贲睥畀铋秕裨筚箅篦舭襞跸髀";
			d[d.length] = "pi:辟坯砒霹批披劈琵毗啤脾疲皮匹痞僻屁譬丕仳陴邳郫圮埤鼙芘擗噼庀淠媲纰枇甓罴铍癖疋蚍蜱貔";
			d[d.length] = "bian:鞭边编贬扁便变卞辨辩辫遍匾弁苄忭汴缏煸砭碥窆褊蝙笾鳊";
			d[d.length] = "biao:标彪膘表婊骠飑飙飚镖镳瘭裱鳔";
			d[d.length] = "bie:鳖憋别瘪蹩";
			d[d.length] = "bin:彬斌濒滨宾摈傧豳缤玢槟殡膑镔髌鬓";
			d[d.length] = "bing:兵冰柄丙秉饼炳病并禀邴摒";
			d[d.length] = "bu:捕卜哺补埠不布步簿部怖卟逋瓿晡钚钸醭";
			d[d.length] = "ca:擦嚓礤";
			d[d.length] = "cai:猜裁材才财睬踩采彩菜蔡";
			d[d.length] = "can:餐参蚕残惭惨灿骖璨粲黪";
			d[d.length] = "cang:苍舱仓沧藏伧";
			d[d.length] = "cao:操糙槽曹草嘈漕螬艚";
			d[d.length] = "ce:厕策侧册测恻";
			d[d.length] = "ceng:层蹭曾噌";
			d[d.length] = "cha:插叉茬茶查碴搽察岔诧猹馇汊姹杈槎檫锸镲衩";
			d[d.length] = "chai:差拆柴豺侪钗瘥虿";
			d[d.length] = "chan:搀掺蝉馋谗缠铲产阐颤冁谄蒇廛忏潺澶孱羼婵骣觇禅蟾躔";
			d[d.length] = "chang:昌猖场尝常长偿肠厂敞畅唱倡伥鬯苌菖徜怅惝阊娼嫦昶氅鲳";
			d[d.length] = "chao:超抄钞朝嘲潮巢吵炒怊晁焯耖";
			d[d.length] = "che:车扯撤掣彻澈坼砗";
			d[d.length] = "chen:郴臣辰尘晨忱沉陈趁衬谌谶抻嗔宸琛榇碜龀";
			d[d.length] = "cheng:撑称城橙成呈乘程惩澄诚承逞骋秤丞埕枨柽塍瞠铖铛裎蛏酲";
			d[d.length] = "chi:吃痴持池迟弛驰耻齿侈尺赤翅斥炽傺墀茌叱哧啻嗤彳饬媸敕眵鸱瘛褫蚩螭笞篪豉踟魑";
			d[d.length] = "shi:匙师失狮施湿诗尸虱十石拾时食蚀实识史矢使屎驶始式示士世柿事拭誓逝势是嗜噬适仕侍释饰氏市恃室视试谥埘莳蓍弑轼贳炻礻铈舐筮豕鲥鲺";
			d[d.length] = "chong:充冲虫崇宠重茺忡憧铳舂艟";
			d[d.length] = "chou:抽酬畴踌稠愁筹仇绸瞅丑臭俦帱惆瘳雠";
			d[d.length] = "chu:初出橱厨躇锄雏滁除楚础储矗搐触处亍刍怵憷绌杵楮樗褚蜍蹰黜";
			d[d.length] = "chuai:揣搋嘬膪踹";
			d[d.length] = "chuan:川穿椽传船喘串舛遄氚钏舡";
			d[d.length] = "chuang:疮窗床闯创怆";
			d[d.length] = "zhuang:幢桩庄装妆撞壮状僮";
			d[d.length] = "chui:吹炊捶锤垂陲棰槌";
			d[d.length] = "chun:春椿醇唇淳纯蠢莼鹑蝽";
			d[d.length] = "chuo:戳绰啜辍踔龊";
			d[d.length] = "ci:疵茨磁雌辞慈瓷词此刺赐次茈祠鹚糍";
			d[d.length] = "cong:聪葱囱匆从丛苁淙骢琮璁枞";
			d[d.length] = "cou:凑楱辏腠";
			d[d.length] = "cu:粗醋簇促卒蔟徂猝殂酢蹙蹴";
			d[d.length] = "cuan:蹿篡窜汆撺爨镩";
			d[d.length] = "cui:摧崔催脆瘁粹淬翠萃啐悴璀榱毳";
			d[d.length] = "cun:村存寸忖皴";
			d[d.length] = "cuo:磋撮搓措挫错厝嵯脞锉矬痤鹾蹉";
			d[d.length] = "da:搭达答瘩打大耷哒怛妲褡笪靼鞑";
			d[d.length] = "dai:呆歹傣戴带殆代贷袋待逮怠埭甙呔岱迨绐玳黛";
			d[d.length] = "dan:耽担丹单郸掸胆旦氮但惮淡诞蛋儋凼萏菪啖澹宕殚赕眈疸瘅聃箪";
			d[d.length] = "tan:弹坍摊贪瘫滩坛檀痰潭谭谈坦毯袒碳探叹炭郯昙忐钽锬覃";
			d[d.length] = "dang:当挡党荡档谠砀裆";
			d[d.length] = "dao:刀捣蹈倒岛祷导到稻悼道盗叨氘焘纛";
			d[d.length] = "de:德得的锝";
			d[d.length] = "deng:蹬灯登等瞪凳邓噔嶝戥磴镫簦";
			d[d.length] = "di:堤低滴迪敌笛狄涤嫡抵底地蒂第帝弟递缔氐籴诋谛邸坻荻嘀娣柢棣觌祗砥碲睇镝羝骶";
			d[d.length] = "zhai:翟摘斋宅窄债寨砦瘵";
			d[d.length] = "dian:颠掂滇碘点典靛垫电佃甸店惦奠淀殿丶阽坫巅玷钿癜癫簟踮";
			d[d.length] = "diao:碉叼雕凋刁掉吊钓铞貂鲷";
			d[d.length] = "tiao:调挑条迢眺跳佻苕祧窕蜩笤粜龆鲦髫";
			d[d.length] = "die:跌爹碟蝶迭谍叠垤堞喋牒瓞耋鲽";
			d[d.length] = "ding:丁盯叮钉顶鼎锭定订仃啶玎腚碇町疔耵酊";
			d[d.length] = "diu:丢铥";
			d[d.length] = "dong:东冬董懂动栋侗恫冻洞垌咚岽峒氡胨胴硐鸫";
			d[d.length] = "dou:兜抖斗陡豆逗痘蔸钭窦蚪篼";
			d[d.length] = "du:都督毒犊独读堵睹赌杜镀肚度渡妒芏嘟渎椟牍蠹笃髑黩";
			d[d.length] = "duan:端短锻段断缎椴煅簖";
			d[d.length] = "dui:堆兑队对怼憝碓镦";
			d[d.length] = "dun:墩吨蹲敦顿钝盾遁沌炖砘礅盹趸";
			d[d.length] = "tun:囤吞屯臀氽饨暾豚";
			d[d.length] = "duo:掇哆多夺垛躲朵跺舵剁惰堕咄哚沲缍铎裰踱";
			d[d.length] = "e:蛾峨鹅俄额讹娥恶厄扼遏鄂饿噩谔垩苊莪萼呃愕屙婀轭腭锇锷鹗颚鳄";
			d[d.length] = "en:恩蒽摁嗯";
			d[d.length] = "er:而儿耳尔饵洱二贰迩珥铒鸸鲕";
			d[d.length] = "fa:发罚筏伐乏阀法珐垡砝";
			d[d.length] = "fan:藩帆番翻樊矾钒繁凡烦反返范贩犯饭泛蕃蘩幡夂梵燔畈蹯";
			d[d.length] = "fang:坊芳方肪房防妨仿访纺放邡枋钫舫鲂";
			d[d.length] = "fei:菲非啡飞肥匪诽吠肺废沸费狒悱淝妃绯榧腓斐扉砩镄痱蜚篚翡霏鲱";
			d[d.length] = "fen:芬酚吩氛分纷坟焚汾粉奋份忿愤粪偾瀵棼鲼鼢";
			d[d.length] = "feng:丰封枫蜂峰锋风疯烽逢冯缝讽奉凤俸酆葑唪沣砜";
			d[d.length] = "fo:佛";
			d[d.length] = "fou:否缶";
			d[d.length] = "fu:夫敷肤孵扶拂辐幅氟符伏俘服浮涪福袱弗甫抚辅俯釜斧脯腑府腐赴副覆赋复傅付阜父腹负富讣附妇缚咐匐凫郛芙芾苻茯莩菔拊呋呒幞怫滏艴孚驸绂绋桴赙祓黻黼罘稃馥蚨蜉蝠蝮麸趺跗鲋鳆";
			d[d.length] = "ga:噶嘎垓尬尕尜旮钆";
			d[d.length] = "gai:该改概钙盖溉丐陔戤赅";
			d[d.length] = "gan:干甘杆柑竿肝赶感秆敢赣坩苷尴擀泔淦澉绀橄旰矸疳酐";
			d[d.length] = "gang:冈刚钢缸肛纲岗港杠戆罡筻";
			d[d.length] = "gao:篙皋高膏羔糕搞镐稿告睾诰郜藁缟槔槁杲锆";
			d[d.length] = "ge:哥歌搁戈鸽胳疙割革葛格阁隔铬个各鬲仡哿圪塥嗝纥搿膈硌镉袼虼舸骼";
			d[d.length] = "ha:蛤哈铪";
			d[d.length] = "gei:给";
			d[d.length] = "gen:根跟亘茛哏艮";
			d[d.length] = "geng:耕更庚羹埂耿梗哽赓绠鲠";
			d[d.length] = "gong:工攻功恭龚供躬公宫弓巩汞拱贡共珙肱蚣觥";
			d[d.length] = "gou:钩勾沟苟狗垢构购够佝诟岣遘媾缑枸觏彀笱篝鞲";
			d[d.length] = "gu:辜菇咕箍估沽孤姑鼓古蛊骨谷股故顾固雇嘏诂菰崮汩梏轱牯牿臌毂瞽罟钴锢鸪痼蛄酤觚鲴";
			d[d.length] = "gua:刮瓜剐寡挂褂卦诖呱栝胍鸹";
			d[d.length] = "guai:乖拐怪掴";
			d[d.length] = "guan:棺关官冠观管馆罐惯灌贯倌莞掼涫盥鹳鳏";
			d[d.length] = "guang:光广逛咣犷桄胱";
			d[d.length] = "gui:瑰规圭硅归龟闺轨鬼诡癸桂柜跪贵刽匦刿庋宄妫桧炅晷皈簋鲑鳜";
			d[d.length] = "gun:辊滚棍衮绲磙鲧";
			d[d.length] = "guo:锅郭国果裹过馘埚呙帼崞猓椁虢聒蜾蝈";
			d[d.length] = "hai:骸孩海氦亥害骇嗨胲醢";
			d[d.length] = "han:酣憨邯韩含涵寒函喊罕翰撼捍旱憾悍焊汗汉邗菡撖犴瀚晗焓顸颔蚶鼾";
			d[d.length] = "hang:夯杭航行沆绗颃";
			d[d.length] = "hao:壕嚎豪毫郝好耗号浩貉蒿薅嗥嚆濠灏昊皓颢蚝";
			d[d.length] = "he:呵喝荷菏核禾和何合盒阂河涸赫褐鹤贺诃劾壑嗬阖曷盍颌蚵翮";
			d[d.length] = "hei:嘿黑";
			d[d.length] = "hen:痕很狠恨";
			d[d.length] = "heng:哼亨横衡恒蘅珩桁";
			d[d.length] = "hong:轰哄烘虹鸿洪宏弘红黉訇讧荭蕻薨闳泓";
			d[d.length] = "hou:喉侯猴吼厚候后堠後逅瘊篌糇鲎骺";
			d[d.length] = "hu:呼乎忽瑚壶葫胡蝴狐糊湖弧虎唬护互沪户冱唿囫岵猢怙惚浒滹琥槲轷觳烀煳戽扈祜瓠鹄鹕鹱笏醐斛鹘";
			d[d.length] = "hua:花哗华猾滑画划化话骅桦砉铧";
			d[d.length] = "huai:槐徊怀淮坏踝";
			d[d.length] = "huan:欢环桓还缓换患唤痪豢焕涣宦幻奂擐圜獾洹浣漶寰逭缳锾鲩鬟";
			d[d.length] = "huang:荒慌黄磺蝗簧皇凰惶煌晃幌恍谎隍徨湟潢遑璜肓癀蟥篁鳇";
			d[d.length] = "hui:灰挥辉徽恢蛔回毁悔慧卉惠晦贿秽会烩汇讳诲绘诙茴荟蕙咴喙隳洄彗缋珲晖恚虺蟪麾";
			d[d.length] = "hun:荤昏婚魂浑混诨馄阍溷";
			d[d.length] = "huo:豁活伙火获或惑霍货祸劐藿攉嚯夥钬锪镬耠蠖";
			d[d.length] = "ji:击圾基机畸稽积箕肌饥迹激讥鸡姬绩缉吉极棘辑籍集及急疾汲即嫉级挤几脊己蓟技冀季伎祭剂悸济寄寂计记既忌际妓继纪藉亟乩剞佶偈墼芨芰荠蒺蕺掎叽咭哜唧岌嵴洎屐骥畿玑楫殛戟戢赍觊犄齑矶羁嵇稷瘠虮笈笄暨跻跽霁鲚鲫髻";
			d[d.length] = "jia:嘉枷夹佳家加荚颊贾甲钾假稼价架驾嫁伽郏葭岬浃迦珈戛胛恝铗镓痂瘕蛱笳袈跏";
			d[d.length] = "jian:歼监坚尖笺间煎兼肩艰奸缄茧检柬碱硷拣捡简俭剪减荐槛鉴践贱见键箭件健舰剑饯渐溅涧建僭谏谫菅蒹搛湔蹇謇缣枧楗戋戬牮犍毽腱睑锏鹣裥笕翦踺鲣鞯";
			d[d.length] = "jiang:僵姜将浆江疆蒋桨奖讲匠酱降茳洚绛缰犟礓耩糨豇";
			d[d.length] = "jiao:蕉椒礁焦胶交郊浇骄娇搅铰矫侥脚狡角饺缴绞剿教酵轿较叫窖佼僬艽茭挢噍峤徼姣敫皎鹪蛟醮跤鲛";
			d[d.length] = "jue:嚼撅攫抉掘倔爵觉决诀绝厥劂谲矍蕨噘崛獗孓珏桷橛爝镢蹶觖";
			d[d.length] = "jie:揭接皆秸街阶截劫节桔杰捷睫竭洁结解姐戒芥界借介疥诫届讦诘拮喈嗟婕孑桀碣疖颉蚧羯鲒骱";
			d[d.length] = "jin:巾筋斤金今津襟紧锦仅谨进靳晋禁近烬浸尽劲卺荩堇噤馑廑妗缙瑾槿赆觐衿矜";
			d[d.length] = "jing:荆兢茎睛晶鲸京惊精粳经井警景颈静境敬镜径痉靖竟竞净刭儆阱菁獍憬泾迳弪婧肼胫腈旌箐";
			d[d.length] = "jiong:炯窘迥扃";
			d[d.length] = "jiu:揪究纠玖韭久灸九酒厩救旧臼舅咎就疚僦啾阄柩桕鸠鹫赳鬏";
			d[d.length] = "ju:鞠拘狙疽居驹菊局咀矩举沮聚拒据巨具距踞锯俱句惧炬剧倨讵苣苴莒掬遽屦琚椐榘榉橘犋飓钜锔窭裾醵踽龃雎鞫";
			d[d.length] = "juan:捐鹃娟倦眷卷绢鄄狷涓桊蠲锩镌隽";
			d[d.length] = "jun:均菌钧军君峻俊竣浚郡骏捃皲筠麇";
			d[d.length] = "ka:喀咖卡佧咔胩";
			d[d.length] = "luo:咯萝螺罗逻锣箩骡裸落洛骆络倮蠃荦摞猡泺漯珞椤脶镙瘰雒";
			d[d.length] = "kai:开揩楷凯慨剀垲蒈忾恺铠锎锴";
			d[d.length] = "kan:刊堪勘坎砍看侃莰阚戡龛瞰";
			d[d.length] = "kang:康慷糠扛抗亢炕伉闶钪";
			d[d.length] = "kao:考拷烤靠尻栲犒铐";
			d[d.length] = "ke:坷苛柯棵磕颗科壳咳可渴克刻客课嗑岢恪溘骒缂珂轲氪瞌钶锞稞疴窠颏蝌髁";
			d[d.length] = "ken:肯啃垦恳裉";
			d[d.length] = "keng:坑吭铿";
			d[d.length] = "kong:空恐孔控倥崆箜";
			d[d.length] = "kou:抠口扣寇芤蔻叩囗眍筘";
			d[d.length] = "ku:枯哭窟苦酷库裤刳堀喾绔骷";
			d[d.length] = "kua:夸垮挎跨胯侉";
			d[d.length] = "kuai:块筷侩快蒯郐哙狯浍脍";
			d[d.length] = "kuan:宽款髋";
			d[d.length] = "kuang:匡筐狂框矿眶旷况诓诳邝圹夼哐纩贶";
			d[d.length] = "kui:亏盔岿窥葵奎魁傀馈愧溃馗匮夔隗蒉揆喹喟悝愦逵暌睽聩蝰篑跬";
			d[d.length] = "kun:坤昆捆困悃阃琨锟醌鲲髡";
			d[d.length] = "kuo:括扩廓阔蛞";
			d[d.length] = "la:垃拉喇蜡腊辣啦剌邋旯砬瘌";
			d[d.length] = "lai:莱来赖崃徕涞濑赉睐铼癞籁";
			d[d.length] = "lan:蓝婪栏拦篮阑兰澜谰揽览懒缆烂滥岚漤榄斓罱镧褴";
			d[d.length] = "lang:琅榔狼廊郎朗浪蒗啷阆稂螂";
			d[d.length] = "lao:捞劳牢老佬姥酪烙涝唠崂忉栳铑铹痨耢醪";
			d[d.length] = "le:勒了仂叻泐鳓";
			d[d.length] = "yue:乐曰约越跃岳粤月悦阅龠哕瀹樾刖钺";
			d[d.length] = "lei:雷镭蕾磊累儡垒擂肋类泪羸诔嘞嫘缧檑耒酹";
			d[d.length] = "leng:棱楞冷塄愣";
			d[d.length] = "li:厘梨犁黎篱狸离漓理李里鲤礼莉荔吏栗丽厉励砾历利傈例俐痢立粒沥隶力璃哩俪俚郦坜苈莅蓠藜呖唳喱猁溧澧逦娌嫠骊缡枥栎轹膦戾砺詈罹锂鹂疠疬蛎蜊蠡笠篥粝醴跞雳鲡鳢黧";
			d[d.length] = "lia:俩";
			d[d.length] = "lian:联莲连镰廉怜涟帘敛脸链恋炼练蔹奁潋濂琏楝殓臁裢裣蠊鲢";
			d[d.length] = "liang:粮凉梁粱良两辆量晾亮谅墚莨椋锒踉靓魉";
			d[d.length] = "liao:撩聊僚疗燎寥辽潦撂镣廖料蓼尥嘹獠寮缭钌鹩";
			d[d.length] = "lie:列裂烈劣猎冽埒捩咧洌趔躐鬣";
			d[d.length] = "lin:琳林磷霖临邻鳞淋凛赁吝拎蔺啉嶙廪懔遴檩辚瞵粼躏麟";
			d[d.length] = "ling:玲菱零龄铃伶羚凌灵陵岭领另令酃苓呤囹泠绫柃棂瓴聆蛉翎鲮";
			d[d.length] = "liu:溜琉榴硫馏留刘瘤流柳六浏遛骝绺旒熘锍镏鹨鎏";
			d[d.length] = "long:龙聋咙笼窿隆垄拢陇垅茏珑栊胧砻癃";
			d[d.length] = "lou:楼娄搂篓漏陋偻蒌喽嵝镂瘘耧蝼髅";
			d[d.length] = "lu:芦卢颅庐炉掳卤虏鲁麓碌露路赂鹿潞禄录陆戮垆撸噜泸渌漉逯璐栌橹轳辂辘氇胪镥鸬鹭簏舻鲈";
			d[d.length] = "lv:驴吕铝侣旅履屡缕虑氯律率滤绿捋闾榈膂稆褛";
			d[d.length] = "luan:峦挛孪滦卵乱脔娈栾鸾銮";
			d[d.length] = "lue:掠略锊";
			d[d.length] = "lun:抡轮伦仑沦纶论囵";
			d[d.length] = "ma:妈麻玛码蚂马骂嘛吗唛犸杩蟆";
			d[d.length] = "mai:埋买麦卖迈脉劢荬霾";
			d[d.length] = "man:瞒馒蛮满蔓曼慢漫谩墁幔缦熳镘颟螨鳗鞔";
			d[d.length] = "mang:芒茫盲氓忙莽邙漭硭蟒";
			d[d.length] = "mao:猫茅锚毛矛铆卯茂冒帽貌贸袤茆峁泖瑁昴牦耄旄懋瞀蝥蟊髦";
			d[d.length] = "me:么麽";
			d[d.length] = "mei:没玫枚梅酶霉煤眉媒镁每美昧寐妹媚莓嵋猸浼湄楣镅鹛袂魅";
			d[d.length] = "mo:摸摹蘑模膜磨摩魔抹末莫墨默沫漠寞陌谟茉蓦馍嫫嬷殁镆秣瘼耱貊貘";
			d[d.length] = "men:门闷们扪焖懑钔";
			d[d.length] = "meng:萌蒙檬盟锰猛梦孟勐甍瞢懵朦礞虻蜢蠓艋艨";
			d[d.length] = "mi:眯醚靡糜迷谜弥米秘觅泌蜜密幂芈谧咪嘧猕汨宓弭脒祢敉縻麋";
			d[d.length] = "mian:棉眠绵冕免勉娩缅面沔渑湎腼眄";
			d[d.length] = "miao:苗描瞄藐秒渺庙妙喵邈缈杪淼眇鹋";
			d[d.length] = "mie:蔑灭乜咩蠛篾";
			d[d.length] = "min:民抿皿敏悯闽苠岷闵泯缗玟珉愍黾鳘";
			d[d.length] = "ming:明螟鸣铭名命冥茗溟暝瞑酩";
			d[d.length] = "miu:谬缪";
			d[d.length] = "mou:谋牟某侔哞眸蛑鍪";
			d[d.length] = "mu:拇牡亩姆母墓暮幕募慕木目睦牧穆仫坶苜沐毪钼";
			d[d.length] = "na:拿哪呐钠那娜纳讷捺肭镎衲";
			d[d.length] = "nai:氖乃奶耐奈鼐佴艿萘柰";
			d[d.length] = "nan:南男难喃囝囡楠腩蝻赧";
			d[d.length] = "nang:囊攮囔馕曩";
			d[d.length] = "nao:挠脑恼闹淖孬垴呶猱瑙硇铙蛲";
			d[d.length] = "ne:呢";
			d[d.length] = "nei:馁内";
			d[d.length] = "nen:嫩恁";
			d[d.length] = "neng:能";
			d[d.length] = "ni:妮霓倪泥尼拟你匿腻逆溺伲坭蘼猊怩昵旎睨铌鲵";
			d[d.length] = "nian:蔫拈年碾撵捻念廿埝辇黏鲇鲶";
			d[d.length] = "niang:娘酿";  
			d[d.length] = "niao:鸟尿茑嬲脲袅";  
			d[d.length] = "nie:捏聂孽啮镊镍涅陧蘖嗫颞臬蹑";  
			d[d.length] = "nin:您";
			d[d.length] = "ning:柠狞凝宁拧泞佞咛甯聍";
			d[d.length] = "niu:牛扭钮纽拗狃忸妞";
			d[d.length] = "nong:脓浓农弄侬哝";
			d[d.length] = "nu:奴努怒弩胬孥驽";
			d[d.length] = "nv:女恧钕衄";
			d[d.length] = "nuan:暖";
			d[d.length] = "nue:虐疟挪";
			d[d.length] = "nuo:懦糯诺傩搦喏锘";
			d[d.length] = "o:哦噢";
			d[d.length] = "ou:欧鸥殴藕呕偶沤讴怄瓯耦";
			d[d.length] = "pa:啪趴爬帕怕琶葩杷筢";
			d[d.length] = "pai:拍排牌徘湃派俳蒎哌";
			d[d.length] = "pan:攀潘盘磐盼畔判叛拚爿泮袢襻蟠蹒";
			d[d.length] = "pang:乓庞旁耪胖彷滂逄螃";
			d[d.length] = "pao:抛咆刨炮袍跑泡匏狍庖脬疱";
			d[d.length] = "pei:呸胚培裴赔陪配佩沛辔帔旆锫醅霈";
			d[d.length] = "pen:喷盆湓";
			d[d.length] = "peng:砰抨烹澎彭蓬棚硼篷膨朋鹏捧碰堋嘭怦蟛";
			d[d.length] = "pian:篇偏片骗谝骈犏胼翩蹁";
			d[d.length] = "piao:飘漂瓢票剽嘌嫖缥殍瞟螵";
			d[d.length] = "pie:撇瞥丿苤氕";
			d[d.length] = "pin:拼频贫品聘姘嫔榀牝颦";  
			d[d.length] = "ping:乒坪苹萍平凭瓶评屏俜娉枰鲆";
			d[d.length] = "po:坡泼颇婆破魄迫粕叵鄱珀钋钷皤笸";
			d[d.length] = "pou:剖裒掊";
			d[d.length] = "pu:扑铺仆莆葡菩蒲埔朴圃普浦谱瀑匍噗溥濮璞氆镤镨蹼";
			d[d.length] = "qi:期欺栖戚妻七凄漆柒沏其棋奇歧畦崎脐齐旗祈祁骑起岂乞企启契砌器气迄弃汽泣讫亓圻芑芪萁萋葺蕲嘁屺岐汔淇骐绮琪琦杞桤槭耆祺憩碛颀蛴蜞綦鳍麒";
			d[d.length] = "qia:掐恰洽葜袷髂";
			d[d.length] = "qian:牵扦钎铅千迁签仟谦乾黔钱钳前潜遣浅谴堑嵌欠歉倩佥阡芊芡茜掮岍悭慊骞搴褰缱椠肷愆钤虔箝";
			d[d.length] = "qiang:枪呛腔羌墙蔷强抢戕嫱樯戗炝锖锵镪襁蜣羟跄";
			d[d.length] = "qiao:橇锹敲悄桥瞧乔侨巧鞘撬翘峭俏窍劁诮谯荞愀憔缲樵硗跷鞒";
			d[d.length] = "qie:切茄且怯窃郄惬妾挈锲箧趄";
			d[d.length] = "qin:钦侵亲秦琴勤芹擒禽寝沁芩揿吣嗪噙溱檎锓螓衾";
			d[d.length] = "qing:青轻氢倾卿清擎晴氰情顷请庆苘圊檠磬蜻罄綮謦鲭黥";
			d[d.length] = "qiong:琼穷邛茕穹蛩筇跫銎";
			d[d.length] = "qiu:秋丘邱球求囚酋泅俅巯犰湫逑遒楸赇虬蚯蝤裘糗鳅鼽";
			d[d.length] = "qu:趋区蛆曲躯屈驱渠取娶龋趣去诎劬蕖蘧岖衢阒璩觑氍朐祛磲鸲癯蛐蠼麴瞿黢";
			d[d.length] = "quan:圈颧权醛泉全痊拳犬券劝诠荃犭悛绻辁畎铨蜷筌鬈";
			d[d.length] = "que:缺炔瘸却鹊榷确雀阕阙悫";
			d[d.length] = "qun:裙群逡";
			d[d.length] = "ran:然燃冉染苒蚺髯";
			d[d.length] = "rang:瓤壤攘嚷让禳穰";
			d[d.length] = "rao:饶扰绕荛娆桡";
			d[d.length] = "re:惹热";
			d[d.length] = "ren:壬仁人忍韧任认刃妊纫仞荏饪轫稔衽";
			d[d.length] = "reng:扔仍";
			d[d.length] = "ri:日";
			d[d.length] = "rong:戎茸蓉荣融熔溶容绒冗嵘狨榕肜蝾";
			d[d.length] = "rou:揉柔肉糅蹂鞣";
			d[d.length] = "ru:茹蠕儒孺如辱乳汝入褥蓐薷嚅洳溽濡缛铷襦颥";
			d[d.length] = "ruan:软阮朊";
			d[d.length] = "rui:蕊瑞锐芮蕤枘睿蚋";
			d[d.length] = "run:闰润";
			d[d.length] = "ruo:若弱偌箬";
			d[d.length] = "sa:撒洒萨卅脎飒";
			d[d.length] = "sai:腮鳃塞赛噻";
			d[d.length] = "san:三叁伞散仨彡馓毵";
			d[d.length] = "sang:桑嗓丧搡磉颡";
			d[d.length] = "sao:搔骚扫嫂埽缫臊瘙鳋";
			d[d.length] = "se:瑟色涩啬铯穑";
			d[d.length] = "sen:森";
			d[d.length] = "seng:僧";
			d[d.length] = "sha:莎砂杀刹沙纱傻啥煞唼歃铩痧裟霎鲨";
			d[d.length] = "shai:筛晒酾";
			d[d.length] = "shan:珊苫杉山删煽衫闪陕擅赡膳善汕扇缮讪鄯芟潸姗嬗骟膻钐疝蟮舢跚鳝";
			d[d.length] = "shang:墒伤商赏晌上尚裳垧泷绱殇熵觞";
			d[d.length] = "shao:梢捎稍烧芍勺韶少哨邵绍劭潲杓筲艄";
			d[d.length] = "she:奢赊蛇舌舍赦摄射慑涉社设厍佘揲猞滠麝";
			d[d.length] = "shen:砷申呻伸身深娠绅神沈审婶甚肾慎渗什诜谂莘葚哂渖椹胂矧蜃糁";
			d[d.length] = "sheng:声生甥牲升绳省盛剩胜圣嵊晟眚笙";
			d[d.length] = "shou:收手首守寿授售受瘦兽狩绶艏";
			d[d.length] = "shu:蔬枢梳殊抒输叔舒淑疏书赎孰熟薯暑曙署蜀黍鼠属术述树束戍竖墅庶数漱恕丨倏塾菽摅沭澍姝纾毹腧殳秫";
			d[d.length] = "shua:刷耍唰";
			d[d.length] = "shuai:摔衰甩帅蟀";
			d[d.length] = "shuan:栓拴闩涮";
			d[d.length] = "shuang:霜双爽孀";
			d[d.length] = "shui:谁水睡税";
			d[d.length] = "shun:吮瞬顺舜";
			d[d.length] = "shuo:说硕朔烁蒴搠妁槊铄";
			d[d.length] = "si:斯撕嘶思私司丝死肆寺嗣四伺似饲巳厮俟兕厶咝汜泗澌姒驷缌祀锶鸶耜蛳笥";
			d[d.length] = "song:松耸怂颂送宋讼诵凇菘崧嵩忪悚淞竦";
			d[d.length] = "sou:搜艘擞嗽叟薮嗖嗾馊溲飕瞍锼螋";
			d[d.length] = "su:苏酥俗素速粟僳塑溯宿诉肃夙谡蔌嗉愫涑簌觫稣";
			d[d.length] = "suan:酸蒜算狻";
			d[d.length] = "sui:虽隋随绥髓碎岁穗遂隧祟谇荽濉邃燧眭睢";
			d[d.length] = "sun:孙损笋荪狲飧榫隼";
			d[d.length] = "suo:蓑梭唆缩琐索锁所唢嗦嗍娑桫挲睃羧";
			d[d.length] = "ta:塌他它她塔獭挞蹋踏嗒闼溻遢榻沓铊趿鳎";
			d[d.length] = "tai:胎苔抬台泰酞太态汰邰薹骀肽炱钛跆鲐";
			d[d.length] = "tang:汤塘搪堂棠膛唐糖倘躺淌趟烫傥帑溏瑭樘铴镗耥螗螳羰醣";
			d[d.length] = "tao:掏涛滔绦萄桃逃淘陶讨套鼗啕洮韬饕";
			d[d.length] = "te:特忑慝铽";
			d[d.length] = "teng:藤腾疼誊滕";
			d[d.length] = "ti:梯剔踢锑提题蹄啼体替嚏惕涕剃屉倜悌逖绨缇鹈裼醍";
			d[d.length] = "tian:天添填田甜恬舔腆掭忝阗殄畋";
			d[d.length] = "tie:贴铁帖萜餮";
			d[d.length] = "ting:厅听烃汀廷停亭庭挺艇莛葶婷梃铤蜓霆";
			d[d.length] = "tong:通桐酮瞳同铜彤童桶捅筒统痛佟仝茼嗵恸潼砼";
			d[d.length] = "tou:偷投头透骰";
			d[d.length] = "tu:凸秃突图徒途涂屠土吐兔堍荼菟钍酴";
			d[d.length] = "tuan:湍团抟彖疃";
			d[d.length] = "tui:推颓腿蜕褪退忒煺";
			d[d.length] = "tuo:拖托脱鸵陀驮驼椭妥拓唾佗坨庹沱柝柁橐砣箨酡跎鼍";
			d[d.length] = "wa:挖哇蛙洼娃瓦袜佤娲腽";
			d[d.length] = "wai:歪外崴";
			d[d.length] = "wan:豌弯湾玩顽丸烷完碗挽晚皖惋宛婉万腕剜芄菀纨绾琬脘畹蜿";
			d[d.length] = "wang:汪王亡枉网往旺望忘妄罔惘辋魍";
			d[d.length] = "wei:威巍微危韦违桅围唯惟为潍维苇萎委伟伪尾纬未蔚味畏胃喂魏位渭谓尉慰卫偎诿隈葳薇帏帷嵬猥猬闱沩洧涠逶娓玮韪軎炜煨痿艉鲔";
			d[d.length] = "wen:瘟温蚊文闻纹吻稳紊问刎阌汶璺攵雯";
			d[d.length] = "weng:嗡翁瓮蓊蕹";
			d[d.length] = "wo:挝蜗涡窝我斡卧握沃倭莴喔幄渥肟硪龌";
			d[d.length] = "wu:巫呜钨乌污诬屋无芜梧吾吴毋武五捂午舞伍侮坞戊雾晤物勿务悟误兀仵阢邬圬芴唔庑怃忤寤迕妩婺骛杌牾焐鹉鹜痦蜈鋈鼯";
			d[d.length] = "xi:昔熙析西硒矽晰嘻吸锡牺稀息希悉膝夕惜熄烯溪汐犀檄袭席习媳喜铣洗系隙戏细僖兮隰郗菥葸蓰奚唏徙饩阋浠淅屣嬉玺樨曦觋欷歙熹禊禧皙穸蜥螅蟋舄舾羲粞翕醯蹊鼷";
			d[d.length] = "xia:瞎虾匣霞辖暇峡侠狭下厦夏吓呷狎遐瑕柙硖罅黠";
			d[d.length] = "xian:掀锨先仙鲜纤咸贤衔舷闲涎弦嫌显险现献县腺馅羡宪陷限线冼苋莶藓岘猃暹娴氙燹祆鹇痫蚬筅籼酰跣跹霰";
			d[d.length] = "xiang:相厢镶香箱襄湘乡翔祥详想响享项巷橡像向象芗葙饷庠骧缃蟓鲞飨";
			d[d.length] = "xiao:萧硝霄削哮嚣销消宵淆晓小孝校肖啸笑效哓崤潇逍骁绡枭枵蛸筱箫魈";
			d[d.length] = "xie:楔些歇蝎鞋协挟携邪斜胁谐写械卸蟹懈泄泻谢屑偕亵勰燮薤撷獬廨渫瀣邂绁缬榭榍蹀躞";
			d[d.length] = "xin:薪芯锌欣辛新忻心信衅囟馨昕歆镡鑫";
			d[d.length] = "xing:星腥猩惺兴刑型形邢醒幸杏性姓陉荇荥擤饧悻硎";
			d[d.length] = "xiong:兄凶胸匈汹雄熊芎";
			d[d.length] = "xiu:休修羞朽嗅锈秀袖绣咻岫馐庥溴鸺貅髹";
			d[d.length] = "xu:墟戌需虚嘘须徐许蓄酗叙旭序畜恤絮婿绪续诩勖圩蓿洫溆顼栩煦盱胥糈醑";
			d[d.length] = "xuan:轩喧宣悬旋玄选癣眩绚儇谖萱揎泫渲漩璇楦暄炫煊碹铉镟痃";
			d[d.length] = "xue:靴薛学穴雪血谑噱泶踅鳕";
			d[d.length] = "xun:勋熏循旬询寻驯巡殉汛训讯逊迅巽郇埙荀荨蕈薰峋徇獯恂洵浔曛醺鲟";
			d[d.length] = "ya:压押鸦鸭呀丫芽牙蚜崖衙涯雅哑亚讶伢垭揠岈迓娅琊桠氩砑睚痖";
			d[d.length] = "yan:焉咽阉烟淹盐严研蜒岩延言颜阎炎沿奄掩眼衍演艳堰燕厌砚雁唁彦焰宴谚验厣赝剡俨偃兖谳郾鄢埏菸崦恹闫阏湮滟妍嫣琰檐晏胭焱罨筵酽趼魇餍鼹";
			d[d.length] = "yang:殃央鸯秧杨扬佯疡羊洋阳氧仰痒养样漾徉怏泱炀烊恙蛘鞅";
			d[d.length] = "yao:邀腰妖瑶摇尧遥窑谣姚咬舀药要耀钥夭爻吆崾徭幺珧杳轺曜肴铫鹞窈鳐";
			d[d.length] = "ye:椰噎耶爷野冶也页掖业叶曳腋夜液靥谒邺揶晔烨铘";
			d[d.length] = "yi:一壹医揖铱依伊衣颐夷遗移仪胰疑沂宜姨彝椅蚁倚已乙矣以艺抑易邑屹亿役臆逸肄疫亦裔意毅忆义益溢诣议谊译异翼翌绎刈劓佚佾诒圯埸懿苡荑薏弈奕挹弋呓咦咿噫峄嶷猗饴怿怡悒漪迤驿缢殪轶贻欹旖熠眙钇镒镱痍瘗癔翊蜴舣羿";
			d[d.length] = "yin:茵荫因殷音阴姻吟银淫寅饮尹引隐印胤鄞垠堙茚吲喑狺夤洇氤铟瘾窨蚓霪龈";
			d[d.length] = "ying:英樱婴鹰应缨莹萤营荧蝇迎赢盈影颖硬映嬴郢茔莺萦蓥撄嘤膺滢潆瀛瑛璎楹媵鹦瘿颍罂";
			d[d.length] = "yo:哟唷";
			d[d.length] = "yong:拥佣臃痈庸雍踊蛹咏泳涌永恿勇用俑壅墉喁慵邕镛甬鳙饔";
			d[d.length] = "you:幽优悠忧尤由邮铀犹油游酉有友右佑釉诱又幼卣攸侑莠莜莸尢呦囿宥柚猷牖铕疣蚰蚴蝣繇鱿黝鼬";
			d[d.length] = "yu:迂淤于盂榆虞愚舆余俞逾鱼愉渝渔隅予娱雨与屿禹宇语羽玉域芋郁吁遇喻峪御愈欲狱育誉浴寓裕预豫驭禺毓伛俣谀谕萸蓣揄圄圉嵛狳饫馀庾阈鬻妪妤纡瑜昱觎腴欤於煜燠聿畲钰鹆鹬瘐瘀窬窳蜮蝓竽臾舁雩龉";
			d[d.length] = "yuan:鸳渊冤元垣袁原援辕园员圆猿源缘远苑愿怨院垸塬芫掾沅媛瑗橼爰眢鸢螈箢鼋";
			d[d.length] = "yun:耘云郧匀陨允运蕴酝晕韵孕郓芸狁恽愠纭韫殒昀氲熨";
			d[d.length] = "za:匝砸杂咋拶咂";
			d[d.length] = "zai:栽哉灾宰载再在崽甾";
			d[d.length] = "zan:咱攒暂赞瓒昝簪糌趱錾";
			d[d.length] = "zang:赃脏葬奘驵臧";
			d[d.length] = "zao:遭糟凿藻枣早澡蚤躁噪造皂灶燥唣";
			d[d.length] = "ze:责择则泽仄赜啧帻迮昃箦舴";
			d[d.length] = "zei:贼";
			d[d.length] = "zen:怎谮";
			d[d.length] = "zeng:增憎赠缯甑罾锃";
			d[d.length] = "zha:扎喳渣札轧铡闸眨栅榨乍炸诈柞揸吒咤哳楂砟痄蚱齄";
			d[d.length] = "zhan:瞻毡詹粘沾盏斩辗崭展蘸栈占战站湛绽谵搌旃";
			d[d.length] = "zhang:樟章彰漳张掌涨杖丈帐账仗胀瘴障仉鄣幛嶂獐嫜璋蟑";
			d[d.length] = "zhao:招昭找沼赵照罩兆肇召着诏棹钊笊";
			d[d.length] = "zhe:遮折哲蛰辙者锗蔗这浙乇谪摺柘辄磔鹧褶蜇螫赭";
			d[d.length] = "zhen:珍斟真甄砧臻贞针侦枕疹诊震振镇阵帧圳蓁浈缜桢榛轸赈胗朕祯畛稹鸩箴";
			d[d.length] = "zheng:蒸挣睁征狰争怔整拯正政症郑证诤峥徵钲铮筝";
			d[d.length] = "zhi:芝枝支吱蜘知肢脂汁之织职直植殖执值侄址指止趾只旨纸志挚掷至致置帜峙制智秩稚质炙痔滞治窒卮陟郅埴芷摭帙忮彘咫骘栉枳栀桎轵轾贽胝膣祉黹雉鸷痣蛭絷酯跖踬踯豸觯";
			d[d.length] = "zhong:中盅忠钟衷终种肿仲众冢锺螽舯踵";
			d[d.length] = "zhou:舟周州洲诌粥轴肘帚咒皱宙昼骤荮啁妯纣绉胄碡籀酎";
			d[d.length] = "zhu:珠株蛛朱猪诸诛逐竹烛煮拄瞩嘱主著柱助蛀贮铸筑住注祝驻伫侏邾苎茱洙渚潴杼槠橥炷铢疰瘃竺箸舳翥躅麈";
			d[d.length] = "zhua:抓爪";
			d[d.length] = "zhuai:拽";
			d[d.length] = "zhuan:专砖转撰赚篆啭馔颛";
			d[d.length] = "zhui:椎锥追赘坠缀萑惴骓缒隹";
			d[d.length] = "zhun:谆准肫窀";
			d[d.length] = "zhuo:捉拙卓桌琢茁酌啄灼浊倬诼擢浞涿濯禚斫镯";
			d[d.length] = "zi:兹咨资姿滋淄孜紫仔籽滓子自渍字谘呲嵫姊孳缁梓辎赀恣眦锱秭耔笫粢趑訾龇鲻髭";
			d[d.length] = "zong:鬃棕踪宗综总纵偬腙粽";
			d[d.length] = "zou:邹走奏揍诹陬鄹驺鲰";
			d[d.length] = "zu:租足族祖诅阻组俎菹镞";
			d[d.length] = "zuan:钻纂攥缵躜";
			d[d.length] = "zui:嘴醉最罪蕞觜";
			d[d.length] = "zun:尊遵撙樽鳟";
			d[d.length] = "zuo:昨左佐做作坐座阼唑怍胙祚笮";
			d[d.length] = "ei:诶";
			d[d.length] = "dia:嗲";
			d[d.length] = "cen:岑涔";
			d[d.length] = "nou:耨";  
			var result = "";
			for ( var i = 0; i < d.length; i++) {
				var pingying = d[i].split(":")[0];
				var hanzi = d[i].split(":")[1];
				if (hanzi.indexOf(input)>-1){
					result = pingying;
					break;
				}
			}
			return result.toUpperCase();
		};
	}
	vx.module('ui.libraries').filter("pingyingConvert",pingyingConvert);
})(window, window.vx);

/*jshint smarttabs:true, eqeqeq:false, eqnull:true, laxbreak:true*/
/**
 * @author
 * filter template
 * 每四位数字一个空格
 */
(function(window, vx) {'use strict';

	function CardPl() {
		return function(input) {
			input = input.replace(/(\d{4})/g,'$1 ').replace(/\s*$/,'');
			return input;
		};
	}
	vx.module('ui.libraries').filter('CardPl', CardPl);

})(window, window.vx);

/**理财：收益类别
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function incomeType() {  
		return function(input) {
			switch (input) {
				case '1':
					input = '非保本浮动收益类';
					break;
				case '2':
					input = '保本浮动收益类';
					break;
				case '3':
					input = '保证收益类';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("incomeType",incomeType);

})(window, window.vx);

/**理财：销售渠道
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function saleChannelType() {  
		return function(input) {
			switch (input) {
				case '00':
					input = '银行柜台';
					break;
				case '01':
					input = '银行网银';
					break;
				case '02':
					input = 'ATM';
					break;
				case '03':
					input = '电话银行';
					break;
				case '04':
					input = '手机银行';
					break;
				case '-1':
					input = '不限渠道';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("saleChannelType",saleChannelType);

})(window, window.vx);

/**理财：产品风险等级
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function riskRankType() {  
		return function(input) {
			switch (input) {
				case '1':
					input = '一级';
					break;
				case '2':
					input = '二级';
					break;
				case '3':
					input = '三级';
					break;
				case '4':
					input = '四级';
					break;
				case '5':
					input = '五级';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("riskRankType",riskRankType);

})(window, window.vx);

/**理财：产品周期类型
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function periodType() {  
		return function(input) {
			switch (input) {
				case '0':
					input = '开放型';
					break;
				case '1':
					input = '封闭型';
					break;
				case '7':
					input = '滚动型';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("periodType",periodType);

})(window, window.vx);

/**理财：交易状态
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function transStateType() {  
		return function(input) {
			switch (input) {
				case '0':
					input = '申请成功 ';
					break;
				case '1':
					input = '申请失败 ';
					break;
				case '2':
					input = '已撤单（成功）';
					break;
				case '3':
					input = '确认成功 ';
					break;
				case '4':
					input = '确认失败';
					break;
				case '5':
					input = '单笔确认失败 ';
					break;
				case '6':
					input = '已撤单（超时）';
					break;
				case '7':
					input = '错误失败';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("transStateType",transStateType);

})(window, window.vx);

/**理财撤单：交易类型
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function transType() {  
		return function(input) {
			switch (input) {
				case '1':
					input = '购买撤单 ';
					break;
				case '2':
					input = '赎回撤单';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("transType",transType);

})(window, window.vx);

/**理财：赎回与否
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function transType() {  
		return function(input) {
			switch (input) {
				case '0':
					input = '不可赎回 ';
					break;
				case '1':
					input = '可赎回';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("transType",transType);

})(window, window.vx);

/**理财：追加与否
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function addMarkType() {  
		return function(input) {
			switch (input) {
				case '0':
					input = '不可追加 ';
					break;
				case '1':
					input = '可追加';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("addMarkType",addMarkType);

})(window, window.vx);


/**理财:分红方式
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function divMethodType() {  
		return function(input) {
			switch (input) {
				case '0':
					input = '红利再投 ';
					break;
				case '1':
					input = '现金分红';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("divMethodType",divMethodType);

})(window, window.vx);

/**理财:客户风险等级承受方式
 * @author 
 * filter template
 */
(function(window, vx, undefined) {'use strict';
	function custLevelType() {  
		return function(input) {
			switch (input) {
				case '1':
					input = '一级(保守型) ';
					break;
				case '2':
					input = '二级(稳健型)';
					break;
				case '3':
					input = '三级(平衡型)';
					break;
				case '4':
					input = '四级(成长型)';
					break;
				case '5':
					input = '五级(进取型)';
					break;
			}
			return input || "";
		};
	}

	vx.module('ui.libraries').filter("custLevelType",custLevelType);

})(window, window.vx);